/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x011f21, CODE_FOR_extendqisi2 },
  { 0x011f22, CODE_FOR_extendqidi2 },
  { 0x012021, CODE_FOR_extendhisi2 },
  { 0x012022, CODE_FOR_extendhidi2 },
  { 0x012122, CODE_FOR_extendsidi2 },
  { 0x013738, CODE_FOR_extendsfdf2 },
  { 0x013739, CODE_FOR_extendsftf2 },
  { 0x01373a, CODE_FOR_extendsfsd2 },
  { 0x01373b, CODE_FOR_extendsfdd2 },
  { 0x01373c, CODE_FOR_extendsftd2 },
  { 0x013837, CODE_FOR_extenddfsf2 },
  { 0x013839, CODE_FOR_extenddftf2 },
  { 0x01383a, CODE_FOR_extenddfsd2 },
  { 0x01383b, CODE_FOR_extenddfdd2 },
  { 0x01383c, CODE_FOR_extenddftd2 },
  { 0x01393a, CODE_FOR_extendtfsd2 },
  { 0x01393b, CODE_FOR_extendtfdd2 },
  { 0x01393c, CODE_FOR_extendtftd2 },
  { 0x013a37, CODE_FOR_extendsdsf2 },
  { 0x013a38, CODE_FOR_extendsddf2 },
  { 0x013a39, CODE_FOR_extendsdtf2 },
  { 0x013a3b, CODE_FOR_extendsddd2 },
  { 0x013a3c, CODE_FOR_extendsdtd2 },
  { 0x013b37, CODE_FOR_extendddsf2 },
  { 0x013b38, CODE_FOR_extenddddf2 },
  { 0x013b39, CODE_FOR_extendddtf2 },
  { 0x013b3c, CODE_FOR_extendddtd2 },
  { 0x013c37, CODE_FOR_extendtdsf2 },
  { 0x013c38, CODE_FOR_extendtddf2 },
  { 0x013c39, CODE_FOR_extendtdtf2 },
  { 0x02373a, CODE_FOR_truncsfsd2 },
  { 0x02373b, CODE_FOR_truncsfdd2 },
  { 0x02373c, CODE_FOR_truncsftd2 },
  { 0x023837, CODE_FOR_truncdfsf2 },
  { 0x02383a, CODE_FOR_truncdfsd2 },
  { 0x02383b, CODE_FOR_truncdfdd2 },
  { 0x02383c, CODE_FOR_truncdftd2 },
  { 0x023937, CODE_FOR_trunctfsf2 },
  { 0x023938, CODE_FOR_trunctfdf2 },
  { 0x02393a, CODE_FOR_trunctfsd2 },
  { 0x02393b, CODE_FOR_trunctfdd2 },
  { 0x02393c, CODE_FOR_trunctftd2 },
  { 0x023a37, CODE_FOR_truncsdsf2 },
  { 0x023a38, CODE_FOR_truncsddf2 },
  { 0x023a39, CODE_FOR_truncsdtf2 },
  { 0x023b37, CODE_FOR_truncddsf2 },
  { 0x023b38, CODE_FOR_truncdddf2 },
  { 0x023b39, CODE_FOR_truncddtf2 },
  { 0x023b3a, CODE_FOR_truncddsd2 },
  { 0x023c37, CODE_FOR_trunctdsf2 },
  { 0x023c38, CODE_FOR_trunctddf2 },
  { 0x023c39, CODE_FOR_trunctdtf2 },
  { 0x023c3a, CODE_FOR_trunctdsd2 },
  { 0x023c3b, CODE_FOR_trunctddd2 },
  { 0x031f20, CODE_FOR_zero_extendqihi2 },
  { 0x031f21, CODE_FOR_zero_extendqisi2 },
  { 0x031f22, CODE_FOR_zero_extendqidi2 },
  { 0x032021, CODE_FOR_zero_extendhisi2 },
  { 0x032022, CODE_FOR_zero_extendhidi2 },
  { 0x032122, CODE_FOR_zero_extendsidi2 },
  { 0x062137, CODE_FOR_floatsisf2 },
  { 0x062138, CODE_FOR_floatsidf2 },
  { 0x062139, CODE_FOR_floatsitf2 },
  { 0x06213b, CODE_FOR_floatsidd2 },
  { 0x06213c, CODE_FOR_floatsitd2 },
  { 0x062237, CODE_FOR_floatdisf2 },
  { 0x062238, CODE_FOR_floatdidf2 },
  { 0x062239, CODE_FOR_floatditf2 },
  { 0x06223b, CODE_FOR_floatdidd2 },
  { 0x06223c, CODE_FOR_floatditd2 },
  { 0x072137, CODE_FOR_floatunssisf2 },
  { 0x072138, CODE_FOR_floatunssidf2 },
  { 0x072139, CODE_FOR_floatunssitf2 },
  { 0x07213b, CODE_FOR_floatunssidd2 },
  { 0x07213c, CODE_FOR_floatunssitd2 },
  { 0x072237, CODE_FOR_floatunsdisf2 },
  { 0x072238, CODE_FOR_floatunsdidf2 },
  { 0x072239, CODE_FOR_floatunsditf2 },
  { 0x07223b, CODE_FOR_floatunsdidd2 },
  { 0x07223c, CODE_FOR_floatunsditd2 },
  { 0x103721, CODE_FOR_fix_truncsfsi2 },
  { 0x103722, CODE_FOR_fix_truncsfdi2 },
  { 0x103821, CODE_FOR_fix_truncdfsi2 },
  { 0x103822, CODE_FOR_fix_truncdfdi2 },
  { 0x103921, CODE_FOR_fix_trunctfsi2 },
  { 0x103922, CODE_FOR_fix_trunctfdi2 },
  { 0x103b22, CODE_FOR_fix_truncdddi2 },
  { 0x103c22, CODE_FOR_fix_trunctddi2 },
  { 0x113721, CODE_FOR_fixuns_truncsfsi2 },
  { 0x113722, CODE_FOR_fixuns_truncsfdi2 },
  { 0x113821, CODE_FOR_fixuns_truncdfsi2 },
  { 0x113822, CODE_FOR_fixuns_truncdfdi2 },
  { 0x113921, CODE_FOR_fixuns_trunctfsi2 },
  { 0x113922, CODE_FOR_fixuns_trunctfdi2 },
  { 0x113b21, CODE_FOR_fixuns_truncddsi2 },
  { 0x113b22, CODE_FOR_fixuns_truncdddi2 },
  { 0x113c21, CODE_FOR_fixuns_trunctdsi2 },
  { 0x113c22, CODE_FOR_fixuns_trunctddi2 },
  { 0x122122, CODE_FOR_mulsidi3 },
  { 0x122223, CODE_FOR_mulditi3 },
  { 0x132122, CODE_FOR_umulsidi3 },
  { 0x132223, CODE_FOR_umulditi3 },
  { 0x1f5050, CODE_FOR_vcondv16qiv16qi },
  { 0x1f5051, CODE_FOR_vcondv8hiv16qi },
  { 0x1f5052, CODE_FOR_vcondv4siv16qi },
  { 0x1f5053, CODE_FOR_vcondv2div16qi },
  { 0x1f5058, CODE_FOR_vcondv4sfv16qi },
  { 0x1f5059, CODE_FOR_vcondv2dfv16qi },
  { 0x1f505a, CODE_FOR_vcondv1tfv16qi },
  { 0x1f5150, CODE_FOR_vcondv16qiv8hi },
  { 0x1f5151, CODE_FOR_vcondv8hiv8hi },
  { 0x1f5152, CODE_FOR_vcondv4siv8hi },
  { 0x1f5153, CODE_FOR_vcondv2div8hi },
  { 0x1f5158, CODE_FOR_vcondv4sfv8hi },
  { 0x1f5159, CODE_FOR_vcondv2dfv8hi },
  { 0x1f515a, CODE_FOR_vcondv1tfv8hi },
  { 0x1f5250, CODE_FOR_vcondv16qiv4si },
  { 0x1f5251, CODE_FOR_vcondv8hiv4si },
  { 0x1f5252, CODE_FOR_vcondv4siv4si },
  { 0x1f5253, CODE_FOR_vcondv2div4si },
  { 0x1f5258, CODE_FOR_vcondv4sfv4si },
  { 0x1f5259, CODE_FOR_vcondv2dfv4si },
  { 0x1f525a, CODE_FOR_vcondv1tfv4si },
  { 0x1f5350, CODE_FOR_vcondv16qiv2di },
  { 0x1f5351, CODE_FOR_vcondv8hiv2di },
  { 0x1f5352, CODE_FOR_vcondv4siv2di },
  { 0x1f5353, CODE_FOR_vcondv2div2di },
  { 0x1f5358, CODE_FOR_vcondv4sfv2di },
  { 0x1f5359, CODE_FOR_vcondv2dfv2di },
  { 0x1f535a, CODE_FOR_vcondv1tfv2di },
  { 0x1f5850, CODE_FOR_vcondv16qiv4sf },
  { 0x1f5851, CODE_FOR_vcondv8hiv4sf },
  { 0x1f5852, CODE_FOR_vcondv4siv4sf },
  { 0x1f5853, CODE_FOR_vcondv2div4sf },
  { 0x1f5858, CODE_FOR_vcondv4sfv4sf },
  { 0x1f5859, CODE_FOR_vcondv2dfv4sf },
  { 0x1f585a, CODE_FOR_vcondv1tfv4sf },
  { 0x1f5950, CODE_FOR_vcondv16qiv2df },
  { 0x1f5951, CODE_FOR_vcondv8hiv2df },
  { 0x1f5952, CODE_FOR_vcondv4siv2df },
  { 0x1f5953, CODE_FOR_vcondv2div2df },
  { 0x1f5958, CODE_FOR_vcondv4sfv2df },
  { 0x1f5959, CODE_FOR_vcondv2dfv2df },
  { 0x1f595a, CODE_FOR_vcondv1tfv2df },
  { 0x1f5a50, CODE_FOR_vcondv16qiv1tf },
  { 0x1f5a51, CODE_FOR_vcondv8hiv1tf },
  { 0x1f5a52, CODE_FOR_vcondv4siv1tf },
  { 0x1f5a53, CODE_FOR_vcondv2div1tf },
  { 0x1f5a58, CODE_FOR_vcondv4sfv1tf },
  { 0x1f5a59, CODE_FOR_vcondv2dfv1tf },
  { 0x1f5a5a, CODE_FOR_vcondv1tfv1tf },
  { 0x205050, CODE_FOR_vconduv16qiv16qi },
  { 0x205051, CODE_FOR_vconduv8hiv16qi },
  { 0x205052, CODE_FOR_vconduv4siv16qi },
  { 0x205053, CODE_FOR_vconduv2div16qi },
  { 0x205058, CODE_FOR_vconduv4sfv16qi },
  { 0x205059, CODE_FOR_vconduv2dfv16qi },
  { 0x20505a, CODE_FOR_vconduv1tfv16qi },
  { 0x205150, CODE_FOR_vconduv16qiv8hi },
  { 0x205151, CODE_FOR_vconduv8hiv8hi },
  { 0x205152, CODE_FOR_vconduv4siv8hi },
  { 0x205153, CODE_FOR_vconduv2div8hi },
  { 0x205158, CODE_FOR_vconduv4sfv8hi },
  { 0x205159, CODE_FOR_vconduv2dfv8hi },
  { 0x20515a, CODE_FOR_vconduv1tfv8hi },
  { 0x205250, CODE_FOR_vconduv16qiv4si },
  { 0x205251, CODE_FOR_vconduv8hiv4si },
  { 0x205252, CODE_FOR_vconduv4siv4si },
  { 0x205253, CODE_FOR_vconduv2div4si },
  { 0x205258, CODE_FOR_vconduv4sfv4si },
  { 0x205259, CODE_FOR_vconduv2dfv4si },
  { 0x20525a, CODE_FOR_vconduv1tfv4si },
  { 0x205350, CODE_FOR_vconduv16qiv2di },
  { 0x205351, CODE_FOR_vconduv8hiv2di },
  { 0x205352, CODE_FOR_vconduv4siv2di },
  { 0x205353, CODE_FOR_vconduv2div2di },
  { 0x205358, CODE_FOR_vconduv4sfv2di },
  { 0x205359, CODE_FOR_vconduv2dfv2di },
  { 0x20535a, CODE_FOR_vconduv1tfv2di },
  { 0x205850, CODE_FOR_vconduv16qiv4sf },
  { 0x205851, CODE_FOR_vconduv8hiv4sf },
  { 0x205852, CODE_FOR_vconduv4siv4sf },
  { 0x205853, CODE_FOR_vconduv2div4sf },
  { 0x205858, CODE_FOR_vconduv4sfv4sf },
  { 0x205859, CODE_FOR_vconduv2dfv4sf },
  { 0x20585a, CODE_FOR_vconduv1tfv4sf },
  { 0x205950, CODE_FOR_vconduv16qiv2df },
  { 0x205951, CODE_FOR_vconduv8hiv2df },
  { 0x205952, CODE_FOR_vconduv4siv2df },
  { 0x205953, CODE_FOR_vconduv2div2df },
  { 0x205958, CODE_FOR_vconduv4sfv2df },
  { 0x205959, CODE_FOR_vconduv2dfv2df },
  { 0x20595a, CODE_FOR_vconduv1tfv2df },
  { 0x205a50, CODE_FOR_vconduv16qiv1tf },
  { 0x205a51, CODE_FOR_vconduv8hiv1tf },
  { 0x205a52, CODE_FOR_vconduv4siv1tf },
  { 0x205a53, CODE_FOR_vconduv2div1tf },
  { 0x205a58, CODE_FOR_vconduv4sfv1tf },
  { 0x205a59, CODE_FOR_vconduv2dfv1tf },
  { 0x205a5a, CODE_FOR_vconduv1tfv1tf },
  { 0x280021, CODE_FOR_addsi3 },
  { 0x280022, CODE_FOR_adddi3 },
  { 0x280023, CODE_FOR_addti3 },
  { 0x280037, CODE_FOR_addsf3 },
  { 0x280038, CODE_FOR_adddf3 },
  { 0x280039, CODE_FOR_addtf3 },
  { 0x28003b, CODE_FOR_adddd3 },
  { 0x28003c, CODE_FOR_addtd3 },
  { 0x280046, CODE_FOR_addv1qi3 },
  { 0x280047, CODE_FOR_addv2qi3 },
  { 0x280048, CODE_FOR_addv1hi3 },
  { 0x280049, CODE_FOR_addv4qi3 },
  { 0x28004a, CODE_FOR_addv2hi3 },
  { 0x28004b, CODE_FOR_addv1si3 },
  { 0x28004c, CODE_FOR_addv8qi3 },
  { 0x28004d, CODE_FOR_addv4hi3 },
  { 0x28004e, CODE_FOR_addv2si3 },
  { 0x28004f, CODE_FOR_addv1di3 },
  { 0x280050, CODE_FOR_addv16qi3 },
  { 0x280051, CODE_FOR_addv8hi3 },
  { 0x280052, CODE_FOR_addv4si3 },
  { 0x280053, CODE_FOR_addv2di3 },
  { 0x280054, CODE_FOR_addv1ti3 },
  { 0x280058, CODE_FOR_addv4sf3 },
  { 0x280059, CODE_FOR_addv2df3 },
  { 0x28005a, CODE_FOR_addv1tf3 },
  { 0x2c0021, CODE_FOR_subsi3 },
  { 0x2c0022, CODE_FOR_subdi3 },
  { 0x2c0023, CODE_FOR_subti3 },
  { 0x2c0037, CODE_FOR_subsf3 },
  { 0x2c0038, CODE_FOR_subdf3 },
  { 0x2c0039, CODE_FOR_subtf3 },
  { 0x2c003b, CODE_FOR_subdd3 },
  { 0x2c003c, CODE_FOR_subtd3 },
  { 0x2c0046, CODE_FOR_subv1qi3 },
  { 0x2c0047, CODE_FOR_subv2qi3 },
  { 0x2c0048, CODE_FOR_subv1hi3 },
  { 0x2c0049, CODE_FOR_subv4qi3 },
  { 0x2c004a, CODE_FOR_subv2hi3 },
  { 0x2c004b, CODE_FOR_subv1si3 },
  { 0x2c004c, CODE_FOR_subv8qi3 },
  { 0x2c004d, CODE_FOR_subv4hi3 },
  { 0x2c004e, CODE_FOR_subv2si3 },
  { 0x2c004f, CODE_FOR_subv1di3 },
  { 0x2c0050, CODE_FOR_subv16qi3 },
  { 0x2c0051, CODE_FOR_subv8hi3 },
  { 0x2c0052, CODE_FOR_subv4si3 },
  { 0x2c0053, CODE_FOR_subv2di3 },
  { 0x2c0054, CODE_FOR_subv1ti3 },
  { 0x2c0058, CODE_FOR_subv4sf3 },
  { 0x2c0059, CODE_FOR_subv2df3 },
  { 0x2c005a, CODE_FOR_subv1tf3 },
  { 0x300021, CODE_FOR_mulsi3 },
  { 0x300022, CODE_FOR_muldi3 },
  { 0x300037, CODE_FOR_mulsf3 },
  { 0x300038, CODE_FOR_muldf3 },
  { 0x300039, CODE_FOR_multf3 },
  { 0x30003b, CODE_FOR_muldd3 },
  { 0x30003c, CODE_FOR_multd3 },
  { 0x300046, CODE_FOR_mulv1qi3 },
  { 0x300047, CODE_FOR_mulv2qi3 },
  { 0x300048, CODE_FOR_mulv1hi3 },
  { 0x300049, CODE_FOR_mulv4qi3 },
  { 0x30004a, CODE_FOR_mulv2hi3 },
  { 0x30004b, CODE_FOR_mulv1si3 },
  { 0x30004c, CODE_FOR_mulv8qi3 },
  { 0x30004d, CODE_FOR_mulv4hi3 },
  { 0x30004e, CODE_FOR_mulv2si3 },
  { 0x300050, CODE_FOR_mulv16qi3 },
  { 0x300051, CODE_FOR_mulv8hi3 },
  { 0x300052, CODE_FOR_mulv4si3 },
  { 0x300058, CODE_FOR_mulv4sf3 },
  { 0x300059, CODE_FOR_mulv2df3 },
  { 0x30005a, CODE_FOR_mulv1tf3 },
  { 0x340037, CODE_FOR_divsf3 },
  { 0x340038, CODE_FOR_divdf3 },
  { 0x340039, CODE_FOR_divtf3 },
  { 0x34003b, CODE_FOR_divdd3 },
  { 0x34003c, CODE_FOR_divtd3 },
  { 0x340058, CODE_FOR_divv4sf3 },
  { 0x340059, CODE_FOR_divv2df3 },
  { 0x34005a, CODE_FOR_divv1tf3 },
  { 0x370021, CODE_FOR_udivsi3 },
  { 0x390021, CODE_FOR_divmodsi4 },
  { 0x390022, CODE_FOR_divmoddi4 },
  { 0x3a0021, CODE_FOR_udivmodsi4 },
  { 0x3a0022, CODE_FOR_udivmoddi4 },
  { 0x3c0021, CODE_FOR_umodsi3 },
  { 0x3e001f, CODE_FOR_andqi3 },
  { 0x3e0020, CODE_FOR_andhi3 },
  { 0x3e0021, CODE_FOR_andsi3 },
  { 0x3e0022, CODE_FOR_anddi3 },
  { 0x3e0023, CODE_FOR_andti3 },
  { 0x3e0046, CODE_FOR_andv1qi3 },
  { 0x3e0047, CODE_FOR_andv2qi3 },
  { 0x3e0048, CODE_FOR_andv1hi3 },
  { 0x3e0049, CODE_FOR_andv4qi3 },
  { 0x3e004a, CODE_FOR_andv2hi3 },
  { 0x3e004b, CODE_FOR_andv1si3 },
  { 0x3e004c, CODE_FOR_andv8qi3 },
  { 0x3e004d, CODE_FOR_andv4hi3 },
  { 0x3e004e, CODE_FOR_andv2si3 },
  { 0x3e004f, CODE_FOR_andv1di3 },
  { 0x3e0050, CODE_FOR_andv16qi3 },
  { 0x3e0051, CODE_FOR_andv8hi3 },
  { 0x3e0052, CODE_FOR_andv4si3 },
  { 0x3e0053, CODE_FOR_andv2di3 },
  { 0x3e0054, CODE_FOR_andv1ti3 },
  { 0x3e0055, CODE_FOR_andv1sf3 },
  { 0x3e0056, CODE_FOR_andv2sf3 },
  { 0x3e0057, CODE_FOR_andv1df3 },
  { 0x3e0058, CODE_FOR_andv4sf3 },
  { 0x3e0059, CODE_FOR_andv2df3 },
  { 0x3e005a, CODE_FOR_andv1tf3 },
  { 0x3f001f, CODE_FOR_iorqi3 },
  { 0x3f0020, CODE_FOR_iorhi3 },
  { 0x3f0021, CODE_FOR_iorsi3 },
  { 0x3f0022, CODE_FOR_iordi3 },
  { 0x3f0023, CODE_FOR_iorti3 },
  { 0x3f0046, CODE_FOR_iorv1qi3 },
  { 0x3f0047, CODE_FOR_iorv2qi3 },
  { 0x3f0048, CODE_FOR_iorv1hi3 },
  { 0x3f0049, CODE_FOR_iorv4qi3 },
  { 0x3f004a, CODE_FOR_iorv2hi3 },
  { 0x3f004b, CODE_FOR_iorv1si3 },
  { 0x3f004c, CODE_FOR_iorv8qi3 },
  { 0x3f004d, CODE_FOR_iorv4hi3 },
  { 0x3f004e, CODE_FOR_iorv2si3 },
  { 0x3f004f, CODE_FOR_iorv1di3 },
  { 0x3f0050, CODE_FOR_iorv16qi3 },
  { 0x3f0051, CODE_FOR_iorv8hi3 },
  { 0x3f0052, CODE_FOR_iorv4si3 },
  { 0x3f0053, CODE_FOR_iorv2di3 },
  { 0x3f0054, CODE_FOR_iorv1ti3 },
  { 0x3f0055, CODE_FOR_iorv1sf3 },
  { 0x3f0056, CODE_FOR_iorv2sf3 },
  { 0x3f0057, CODE_FOR_iorv1df3 },
  { 0x3f0058, CODE_FOR_iorv4sf3 },
  { 0x3f0059, CODE_FOR_iorv2df3 },
  { 0x3f005a, CODE_FOR_iorv1tf3 },
  { 0x40001f, CODE_FOR_xorqi3 },
  { 0x400020, CODE_FOR_xorhi3 },
  { 0x400021, CODE_FOR_xorsi3 },
  { 0x400022, CODE_FOR_xordi3 },
  { 0x400023, CODE_FOR_xorti3 },
  { 0x400046, CODE_FOR_xorv1qi3 },
  { 0x400047, CODE_FOR_xorv2qi3 },
  { 0x400048, CODE_FOR_xorv1hi3 },
  { 0x400049, CODE_FOR_xorv4qi3 },
  { 0x40004a, CODE_FOR_xorv2hi3 },
  { 0x40004b, CODE_FOR_xorv1si3 },
  { 0x40004c, CODE_FOR_xorv8qi3 },
  { 0x40004d, CODE_FOR_xorv4hi3 },
  { 0x40004e, CODE_FOR_xorv2si3 },
  { 0x40004f, CODE_FOR_xorv1di3 },
  { 0x400050, CODE_FOR_xorv16qi3 },
  { 0x400051, CODE_FOR_xorv8hi3 },
  { 0x400052, CODE_FOR_xorv4si3 },
  { 0x400053, CODE_FOR_xorv2di3 },
  { 0x400054, CODE_FOR_xorv1ti3 },
  { 0x400055, CODE_FOR_xorv1sf3 },
  { 0x400056, CODE_FOR_xorv2sf3 },
  { 0x400057, CODE_FOR_xorv1df3 },
  { 0x400058, CODE_FOR_xorv4sf3 },
  { 0x400059, CODE_FOR_xorv2df3 },
  { 0x40005a, CODE_FOR_xorv1tf3 },
  { 0x410021, CODE_FOR_ashlsi3 },
  { 0x410022, CODE_FOR_ashldi3 },
  { 0x410046, CODE_FOR_ashlv1qi3 },
  { 0x410047, CODE_FOR_ashlv2qi3 },
  { 0x410048, CODE_FOR_ashlv1hi3 },
  { 0x410049, CODE_FOR_ashlv4qi3 },
  { 0x41004a, CODE_FOR_ashlv2hi3 },
  { 0x41004b, CODE_FOR_ashlv1si3 },
  { 0x41004c, CODE_FOR_ashlv8qi3 },
  { 0x41004d, CODE_FOR_ashlv4hi3 },
  { 0x41004e, CODE_FOR_ashlv2si3 },
  { 0x41004f, CODE_FOR_ashlv1di3 },
  { 0x410050, CODE_FOR_ashlv16qi3 },
  { 0x410051, CODE_FOR_ashlv8hi3 },
  { 0x410052, CODE_FOR_ashlv4si3 },
  { 0x410053, CODE_FOR_ashlv2di3 },
  { 0x440021, CODE_FOR_ashrsi3 },
  { 0x440022, CODE_FOR_ashrdi3 },
  { 0x440046, CODE_FOR_ashrv1qi3 },
  { 0x440047, CODE_FOR_ashrv2qi3 },
  { 0x440048, CODE_FOR_ashrv1hi3 },
  { 0x440049, CODE_FOR_ashrv4qi3 },
  { 0x44004a, CODE_FOR_ashrv2hi3 },
  { 0x44004b, CODE_FOR_ashrv1si3 },
  { 0x44004c, CODE_FOR_ashrv8qi3 },
  { 0x44004d, CODE_FOR_ashrv4hi3 },
  { 0x44004e, CODE_FOR_ashrv2si3 },
  { 0x44004f, CODE_FOR_ashrv1di3 },
  { 0x440050, CODE_FOR_ashrv16qi3 },
  { 0x440051, CODE_FOR_ashrv8hi3 },
  { 0x440052, CODE_FOR_ashrv4si3 },
  { 0x440053, CODE_FOR_ashrv2di3 },
  { 0x450021, CODE_FOR_lshrsi3 },
  { 0x450022, CODE_FOR_lshrdi3 },
  { 0x450046, CODE_FOR_lshrv1qi3 },
  { 0x450047, CODE_FOR_lshrv2qi3 },
  { 0x450048, CODE_FOR_lshrv1hi3 },
  { 0x450049, CODE_FOR_lshrv4qi3 },
  { 0x45004a, CODE_FOR_lshrv2hi3 },
  { 0x45004b, CODE_FOR_lshrv1si3 },
  { 0x45004c, CODE_FOR_lshrv8qi3 },
  { 0x45004d, CODE_FOR_lshrv4hi3 },
  { 0x45004e, CODE_FOR_lshrv2si3 },
  { 0x45004f, CODE_FOR_lshrv1di3 },
  { 0x450050, CODE_FOR_lshrv16qi3 },
  { 0x450051, CODE_FOR_lshrv8hi3 },
  { 0x450052, CODE_FOR_lshrv4si3 },
  { 0x450053, CODE_FOR_lshrv2di3 },
  { 0x460021, CODE_FOR_rotlsi3 },
  { 0x460022, CODE_FOR_rotldi3 },
  { 0x460046, CODE_FOR_rotlv1qi3 },
  { 0x460047, CODE_FOR_rotlv2qi3 },
  { 0x460048, CODE_FOR_rotlv1hi3 },
  { 0x460049, CODE_FOR_rotlv4qi3 },
  { 0x46004a, CODE_FOR_rotlv2hi3 },
  { 0x46004b, CODE_FOR_rotlv1si3 },
  { 0x46004c, CODE_FOR_rotlv8qi3 },
  { 0x46004d, CODE_FOR_rotlv4hi3 },
  { 0x46004e, CODE_FOR_rotlv2si3 },
  { 0x46004f, CODE_FOR_rotlv1di3 },
  { 0x460050, CODE_FOR_rotlv16qi3 },
  { 0x460051, CODE_FOR_rotlv8hi3 },
  { 0x460052, CODE_FOR_rotlv4si3 },
  { 0x460053, CODE_FOR_rotlv2di3 },
  { 0x480046, CODE_FOR_vashlv1qi3 },
  { 0x480047, CODE_FOR_vashlv2qi3 },
  { 0x480048, CODE_FOR_vashlv1hi3 },
  { 0x480049, CODE_FOR_vashlv4qi3 },
  { 0x48004a, CODE_FOR_vashlv2hi3 },
  { 0x48004b, CODE_FOR_vashlv1si3 },
  { 0x48004c, CODE_FOR_vashlv8qi3 },
  { 0x48004d, CODE_FOR_vashlv4hi3 },
  { 0x48004e, CODE_FOR_vashlv2si3 },
  { 0x48004f, CODE_FOR_vashlv1di3 },
  { 0x480050, CODE_FOR_vashlv16qi3 },
  { 0x480051, CODE_FOR_vashlv8hi3 },
  { 0x480052, CODE_FOR_vashlv4si3 },
  { 0x480053, CODE_FOR_vashlv2di3 },
  { 0x490046, CODE_FOR_vashrv1qi3 },
  { 0x490047, CODE_FOR_vashrv2qi3 },
  { 0x490048, CODE_FOR_vashrv1hi3 },
  { 0x490049, CODE_FOR_vashrv4qi3 },
  { 0x49004a, CODE_FOR_vashrv2hi3 },
  { 0x49004b, CODE_FOR_vashrv1si3 },
  { 0x49004c, CODE_FOR_vashrv8qi3 },
  { 0x49004d, CODE_FOR_vashrv4hi3 },
  { 0x49004e, CODE_FOR_vashrv2si3 },
  { 0x49004f, CODE_FOR_vashrv1di3 },
  { 0x490050, CODE_FOR_vashrv16qi3 },
  { 0x490051, CODE_FOR_vashrv8hi3 },
  { 0x490052, CODE_FOR_vashrv4si3 },
  { 0x490053, CODE_FOR_vashrv2di3 },
  { 0x4a0046, CODE_FOR_vlshrv1qi3 },
  { 0x4a0047, CODE_FOR_vlshrv2qi3 },
  { 0x4a0048, CODE_FOR_vlshrv1hi3 },
  { 0x4a0049, CODE_FOR_vlshrv4qi3 },
  { 0x4a004a, CODE_FOR_vlshrv2hi3 },
  { 0x4a004b, CODE_FOR_vlshrv1si3 },
  { 0x4a004c, CODE_FOR_vlshrv8qi3 },
  { 0x4a004d, CODE_FOR_vlshrv4hi3 },
  { 0x4a004e, CODE_FOR_vlshrv2si3 },
  { 0x4a004f, CODE_FOR_vlshrv1di3 },
  { 0x4a0050, CODE_FOR_vlshrv16qi3 },
  { 0x4a0051, CODE_FOR_vlshrv8hi3 },
  { 0x4a0052, CODE_FOR_vlshrv4si3 },
  { 0x4a0053, CODE_FOR_vlshrv2di3 },
  { 0x4b0046, CODE_FOR_vrotlv1qi3 },
  { 0x4b0047, CODE_FOR_vrotlv2qi3 },
  { 0x4b0048, CODE_FOR_vrotlv1hi3 },
  { 0x4b0049, CODE_FOR_vrotlv4qi3 },
  { 0x4b004a, CODE_FOR_vrotlv2hi3 },
  { 0x4b004b, CODE_FOR_vrotlv1si3 },
  { 0x4b004c, CODE_FOR_vrotlv8qi3 },
  { 0x4b004d, CODE_FOR_vrotlv4hi3 },
  { 0x4b004e, CODE_FOR_vrotlv2si3 },
  { 0x4b004f, CODE_FOR_vrotlv1di3 },
  { 0x4b0050, CODE_FOR_vrotlv16qi3 },
  { 0x4b0051, CODE_FOR_vrotlv8hi3 },
  { 0x4b0052, CODE_FOR_vrotlv4si3 },
  { 0x4b0053, CODE_FOR_vrotlv2di3 },
  { 0x4d0046, CODE_FOR_sminv1qi3 },
  { 0x4d0047, CODE_FOR_sminv2qi3 },
  { 0x4d0048, CODE_FOR_sminv1hi3 },
  { 0x4d0049, CODE_FOR_sminv4qi3 },
  { 0x4d004a, CODE_FOR_sminv2hi3 },
  { 0x4d004b, CODE_FOR_sminv1si3 },
  { 0x4d004c, CODE_FOR_sminv8qi3 },
  { 0x4d004d, CODE_FOR_sminv4hi3 },
  { 0x4d004e, CODE_FOR_sminv2si3 },
  { 0x4d004f, CODE_FOR_sminv1di3 },
  { 0x4d0050, CODE_FOR_sminv16qi3 },
  { 0x4d0051, CODE_FOR_sminv8hi3 },
  { 0x4d0052, CODE_FOR_sminv4si3 },
  { 0x4d0053, CODE_FOR_sminv2di3 },
  { 0x4d0058, CODE_FOR_sminv4sf3 },
  { 0x4d0059, CODE_FOR_sminv2df3 },
  { 0x4d005a, CODE_FOR_sminv1tf3 },
  { 0x4e0046, CODE_FOR_smaxv1qi3 },
  { 0x4e0047, CODE_FOR_smaxv2qi3 },
  { 0x4e0048, CODE_FOR_smaxv1hi3 },
  { 0x4e0049, CODE_FOR_smaxv4qi3 },
  { 0x4e004a, CODE_FOR_smaxv2hi3 },
  { 0x4e004b, CODE_FOR_smaxv1si3 },
  { 0x4e004c, CODE_FOR_smaxv8qi3 },
  { 0x4e004d, CODE_FOR_smaxv4hi3 },
  { 0x4e004e, CODE_FOR_smaxv2si3 },
  { 0x4e004f, CODE_FOR_smaxv1di3 },
  { 0x4e0050, CODE_FOR_smaxv16qi3 },
  { 0x4e0051, CODE_FOR_smaxv8hi3 },
  { 0x4e0052, CODE_FOR_smaxv4si3 },
  { 0x4e0053, CODE_FOR_smaxv2di3 },
  { 0x4e0058, CODE_FOR_smaxv4sf3 },
  { 0x4e0059, CODE_FOR_smaxv2df3 },
  { 0x4e005a, CODE_FOR_smaxv1tf3 },
  { 0x4f0046, CODE_FOR_uminv1qi3 },
  { 0x4f0047, CODE_FOR_uminv2qi3 },
  { 0x4f0048, CODE_FOR_uminv1hi3 },
  { 0x4f0049, CODE_FOR_uminv4qi3 },
  { 0x4f004a, CODE_FOR_uminv2hi3 },
  { 0x4f004b, CODE_FOR_uminv1si3 },
  { 0x4f004c, CODE_FOR_uminv8qi3 },
  { 0x4f004d, CODE_FOR_uminv4hi3 },
  { 0x4f004e, CODE_FOR_uminv2si3 },
  { 0x4f004f, CODE_FOR_uminv1di3 },
  { 0x4f0050, CODE_FOR_uminv16qi3 },
  { 0x4f0051, CODE_FOR_uminv8hi3 },
  { 0x4f0052, CODE_FOR_uminv4si3 },
  { 0x4f0053, CODE_FOR_uminv2di3 },
  { 0x500046, CODE_FOR_umaxv1qi3 },
  { 0x500047, CODE_FOR_umaxv2qi3 },
  { 0x500048, CODE_FOR_umaxv1hi3 },
  { 0x500049, CODE_FOR_umaxv4qi3 },
  { 0x50004a, CODE_FOR_umaxv2hi3 },
  { 0x50004b, CODE_FOR_umaxv1si3 },
  { 0x50004c, CODE_FOR_umaxv8qi3 },
  { 0x50004d, CODE_FOR_umaxv4hi3 },
  { 0x50004e, CODE_FOR_umaxv2si3 },
  { 0x50004f, CODE_FOR_umaxv1di3 },
  { 0x500050, CODE_FOR_umaxv16qi3 },
  { 0x500051, CODE_FOR_umaxv8hi3 },
  { 0x500052, CODE_FOR_umaxv4si3 },
  { 0x500053, CODE_FOR_umaxv2di3 },
  { 0x510021, CODE_FOR_negsi2 },
  { 0x510022, CODE_FOR_negdi2 },
  { 0x510037, CODE_FOR_negsf2 },
  { 0x510038, CODE_FOR_negdf2 },
  { 0x510039, CODE_FOR_negtf2 },
  { 0x510046, CODE_FOR_negv1qi2 },
  { 0x510047, CODE_FOR_negv2qi2 },
  { 0x510048, CODE_FOR_negv1hi2 },
  { 0x510049, CODE_FOR_negv4qi2 },
  { 0x51004a, CODE_FOR_negv2hi2 },
  { 0x51004b, CODE_FOR_negv1si2 },
  { 0x51004c, CODE_FOR_negv8qi2 },
  { 0x51004d, CODE_FOR_negv4hi2 },
  { 0x51004e, CODE_FOR_negv2si2 },
  { 0x51004f, CODE_FOR_negv1di2 },
  { 0x510050, CODE_FOR_negv16qi2 },
  { 0x510051, CODE_FOR_negv8hi2 },
  { 0x510052, CODE_FOR_negv4si2 },
  { 0x510053, CODE_FOR_negv2di2 },
  { 0x510055, CODE_FOR_negv1sf2 },
  { 0x510056, CODE_FOR_negv2sf2 },
  { 0x510057, CODE_FOR_negv1df2 },
  { 0x510058, CODE_FOR_negv4sf2 },
  { 0x510059, CODE_FOR_negv2df2 },
  { 0x51005a, CODE_FOR_negv1tf2 },
  { 0x550021, CODE_FOR_abssi2 },
  { 0x550022, CODE_FOR_absdi2 },
  { 0x550037, CODE_FOR_abssf2 },
  { 0x550038, CODE_FOR_absdf2 },
  { 0x550039, CODE_FOR_abstf2 },
  { 0x550046, CODE_FOR_absv1qi2 },
  { 0x550047, CODE_FOR_absv2qi2 },
  { 0x550048, CODE_FOR_absv1hi2 },
  { 0x550049, CODE_FOR_absv4qi2 },
  { 0x55004a, CODE_FOR_absv2hi2 },
  { 0x55004b, CODE_FOR_absv1si2 },
  { 0x55004c, CODE_FOR_absv8qi2 },
  { 0x55004d, CODE_FOR_absv4hi2 },
  { 0x55004e, CODE_FOR_absv2si2 },
  { 0x55004f, CODE_FOR_absv1di2 },
  { 0x550050, CODE_FOR_absv16qi2 },
  { 0x550051, CODE_FOR_absv8hi2 },
  { 0x550052, CODE_FOR_absv4si2 },
  { 0x550053, CODE_FOR_absv2di2 },
  { 0x550055, CODE_FOR_absv1sf2 },
  { 0x550056, CODE_FOR_absv2sf2 },
  { 0x550057, CODE_FOR_absv1df2 },
  { 0x550058, CODE_FOR_absv4sf2 },
  { 0x550059, CODE_FOR_absv2df2 },
  { 0x55005a, CODE_FOR_absv1tf2 },
  { 0x57001f, CODE_FOR_one_cmplqi2 },
  { 0x570020, CODE_FOR_one_cmplhi2 },
  { 0x570021, CODE_FOR_one_cmplsi2 },
  { 0x570022, CODE_FOR_one_cmpldi2 },
  { 0x570023, CODE_FOR_one_cmplti2 },
  { 0x570046, CODE_FOR_one_cmplv1qi2 },
  { 0x570047, CODE_FOR_one_cmplv2qi2 },
  { 0x570048, CODE_FOR_one_cmplv1hi2 },
  { 0x570049, CODE_FOR_one_cmplv4qi2 },
  { 0x57004a, CODE_FOR_one_cmplv2hi2 },
  { 0x57004b, CODE_FOR_one_cmplv1si2 },
  { 0x57004c, CODE_FOR_one_cmplv8qi2 },
  { 0x57004d, CODE_FOR_one_cmplv4hi2 },
  { 0x57004e, CODE_FOR_one_cmplv2si2 },
  { 0x57004f, CODE_FOR_one_cmplv1di2 },
  { 0x570050, CODE_FOR_one_cmplv16qi2 },
  { 0x570051, CODE_FOR_one_cmplv8hi2 },
  { 0x570052, CODE_FOR_one_cmplv4si2 },
  { 0x570053, CODE_FOR_one_cmplv2di2 },
  { 0x570054, CODE_FOR_one_cmplv1ti2 },
  { 0x570055, CODE_FOR_one_cmplv1sf2 },
  { 0x570056, CODE_FOR_one_cmplv2sf2 },
  { 0x570057, CODE_FOR_one_cmplv1df2 },
  { 0x570058, CODE_FOR_one_cmplv4sf2 },
  { 0x570059, CODE_FOR_one_cmplv2df2 },
  { 0x57005a, CODE_FOR_one_cmplv1tf2 },
  { 0x580020, CODE_FOR_bswaphi2 },
  { 0x580021, CODE_FOR_bswapsi2 },
  { 0x580022, CODE_FOR_bswapdi2 },
  { 0x5a0022, CODE_FOR_clzdi2 },
  { 0x5a0046, CODE_FOR_clzv1qi2 },
  { 0x5a0047, CODE_FOR_clzv2qi2 },
  { 0x5a0048, CODE_FOR_clzv1hi2 },
  { 0x5a0049, CODE_FOR_clzv4qi2 },
  { 0x5a004a, CODE_FOR_clzv2hi2 },
  { 0x5a004b, CODE_FOR_clzv1si2 },
  { 0x5a004c, CODE_FOR_clzv8qi2 },
  { 0x5a004d, CODE_FOR_clzv4hi2 },
  { 0x5a004e, CODE_FOR_clzv2si2 },
  { 0x5a004f, CODE_FOR_clzv1di2 },
  { 0x5a0050, CODE_FOR_clzv16qi2 },
  { 0x5a0051, CODE_FOR_clzv8hi2 },
  { 0x5a0052, CODE_FOR_clzv4si2 },
  { 0x5a0053, CODE_FOR_clzv2di2 },
  { 0x5a0055, CODE_FOR_clzv1sf2 },
  { 0x5a0056, CODE_FOR_clzv2sf2 },
  { 0x5a0057, CODE_FOR_clzv1df2 },
  { 0x5a0058, CODE_FOR_clzv4sf2 },
  { 0x5a0059, CODE_FOR_clzv2df2 },
  { 0x5b0046, CODE_FOR_ctzv1qi2 },
  { 0x5b0047, CODE_FOR_ctzv2qi2 },
  { 0x5b0048, CODE_FOR_ctzv1hi2 },
  { 0x5b0049, CODE_FOR_ctzv4qi2 },
  { 0x5b004a, CODE_FOR_ctzv2hi2 },
  { 0x5b004b, CODE_FOR_ctzv1si2 },
  { 0x5b004c, CODE_FOR_ctzv8qi2 },
  { 0x5b004d, CODE_FOR_ctzv4hi2 },
  { 0x5b004e, CODE_FOR_ctzv2si2 },
  { 0x5b004f, CODE_FOR_ctzv1di2 },
  { 0x5b0050, CODE_FOR_ctzv16qi2 },
  { 0x5b0051, CODE_FOR_ctzv8hi2 },
  { 0x5b0052, CODE_FOR_ctzv4si2 },
  { 0x5b0053, CODE_FOR_ctzv2di2 },
  { 0x5b0055, CODE_FOR_ctzv1sf2 },
  { 0x5b0056, CODE_FOR_ctzv2sf2 },
  { 0x5b0057, CODE_FOR_ctzv1df2 },
  { 0x5b0058, CODE_FOR_ctzv4sf2 },
  { 0x5b0059, CODE_FOR_ctzv2df2 },
  { 0x5d001f, CODE_FOR_popcountqi2 },
  { 0x5d0020, CODE_FOR_popcounthi2 },
  { 0x5d0021, CODE_FOR_popcountsi2 },
  { 0x5d0022, CODE_FOR_popcountdi2 },
  { 0x5d0050, CODE_FOR_popcountv16qi2 },
  { 0x5d0051, CODE_FOR_popcountv8hi2 },
  { 0x5d0052, CODE_FOR_popcountv4si2 },
  { 0x5d0053, CODE_FOR_popcountv2di2 },
  { 0x690037, CODE_FOR_sqrtsf2 },
  { 0x690038, CODE_FOR_sqrtdf2 },
  { 0x690039, CODE_FOR_sqrttf2 },
  { 0x690058, CODE_FOR_sqrtv4sf2 },
  { 0x690059, CODE_FOR_sqrtv2df2 },
  { 0x69005a, CODE_FOR_sqrtv1tf2 },
  { 0x780002, CODE_FOR_movcc },
  { 0x78001f, CODE_FOR_movqi },
  { 0x780020, CODE_FOR_movhi },
  { 0x780021, CODE_FOR_movsi },
  { 0x780022, CODE_FOR_movdi },
  { 0x780023, CODE_FOR_movti },
  { 0x780037, CODE_FOR_movsf },
  { 0x780038, CODE_FOR_movdf },
  { 0x780039, CODE_FOR_movtf },
  { 0x78003a, CODE_FOR_movsd },
  { 0x78003b, CODE_FOR_movdd },
  { 0x78003c, CODE_FOR_movtd },
  { 0x780046, CODE_FOR_movv1qi },
  { 0x780047, CODE_FOR_movv2qi },
  { 0x780048, CODE_FOR_movv1hi },
  { 0x780049, CODE_FOR_movv4qi },
  { 0x78004a, CODE_FOR_movv2hi },
  { 0x78004b, CODE_FOR_movv1si },
  { 0x78004c, CODE_FOR_movv8qi },
  { 0x78004d, CODE_FOR_movv4hi },
  { 0x78004e, CODE_FOR_movv2si },
  { 0x78004f, CODE_FOR_movv1di },
  { 0x780050, CODE_FOR_movv16qi },
  { 0x780051, CODE_FOR_movv8hi },
  { 0x780052, CODE_FOR_movv4si },
  { 0x780053, CODE_FOR_movv2di },
  { 0x780054, CODE_FOR_movv1ti },
  { 0x780055, CODE_FOR_movv1sf },
  { 0x780056, CODE_FOR_movv2sf },
  { 0x780057, CODE_FOR_movv1df },
  { 0x780058, CODE_FOR_movv4sf },
  { 0x780059, CODE_FOR_movv2df },
  { 0x78005a, CODE_FOR_movv1tf },
  { 0x790021, CODE_FOR_movstrictsi },
  { 0x850002, CODE_FOR_cbranchcc4 },
  { 0x850021, CODE_FOR_cbranchsi4 },
  { 0x850022, CODE_FOR_cbranchdi4 },
  { 0x850037, CODE_FOR_cbranchsf4 },
  { 0x850038, CODE_FOR_cbranchdf4 },
  { 0x850039, CODE_FOR_cbranchtf4 },
  { 0x85003b, CODE_FOR_cbranchdd4 },
  { 0x85003c, CODE_FOR_cbranchtd4 },
  { 0x860021, CODE_FOR_addsicc },
  { 0x860022, CODE_FOR_adddicc },
  { 0x890021, CODE_FOR_movsicc },
  { 0x890022, CODE_FOR_movdicc },
  { 0x8b0002, CODE_FOR_cstorecc4 },
  { 0x8b0021, CODE_FOR_cstoresi4 },
  { 0x8b0022, CODE_FOR_cstoredi4 },
  { 0x8c0021, CODE_FOR_ctrapsi4 },
  { 0x8c0022, CODE_FOR_ctrapdi4 },
  { 0x8c0037, CODE_FOR_ctrapsf4 },
  { 0x8c0038, CODE_FOR_ctrapdf4 },
  { 0x8c0039, CODE_FOR_ctraptf4 },
  { 0x8c003b, CODE_FOR_ctrapdd4 },
  { 0x8c003c, CODE_FOR_ctraptd4 },
  { 0x940021, CODE_FOR_addptrsi3 },
  { 0x940022, CODE_FOR_addptrdi3 },
  { 0x970021, CODE_FOR_cmpmemsi },
  { 0x980021, CODE_FOR_cmpstrsi },
  { 0x9a0021, CODE_FOR_movmemsi },
  { 0x9a0022, CODE_FOR_movmemdi },
  { 0x9b0021, CODE_FOR_setmemsi },
  { 0x9b0022, CODE_FOR_setmemdi },
  { 0x9c0021, CODE_FOR_strlensi },
  { 0x9c0022, CODE_FOR_strlendi },
  { 0x9d0037, CODE_FOR_fmasf4 },
  { 0x9d0038, CODE_FOR_fmadf4 },
  { 0x9d0058, CODE_FOR_fmav4sf4 },
  { 0x9d0059, CODE_FOR_fmav2df4 },
  { 0x9d005a, CODE_FOR_fmav1tf4 },
  { 0x9e0037, CODE_FOR_fmssf4 },
  { 0x9e0038, CODE_FOR_fmsdf4 },
  { 0x9e0058, CODE_FOR_fmsv4sf4 },
  { 0x9e0059, CODE_FOR_fmsv2df4 },
  { 0x9e005a, CODE_FOR_fmsv1tf4 },
  { 0xa10037, CODE_FOR_rintsf2 },
  { 0xa10038, CODE_FOR_rintdf2 },
  { 0xa10039, CODE_FOR_rinttf2 },
  { 0xa1003b, CODE_FOR_rintdd2 },
  { 0xa1003c, CODE_FOR_rinttd2 },
  { 0xa20037, CODE_FOR_roundsf2 },
  { 0xa20038, CODE_FOR_rounddf2 },
  { 0xa20039, CODE_FOR_roundtf2 },
  { 0xa2003b, CODE_FOR_rounddd2 },
  { 0xa2003c, CODE_FOR_roundtd2 },
  { 0xa30037, CODE_FOR_floorsf2 },
  { 0xa30038, CODE_FOR_floordf2 },
  { 0xa30039, CODE_FOR_floortf2 },
  { 0xa3003b, CODE_FOR_floordd2 },
  { 0xa3003c, CODE_FOR_floortd2 },
  { 0xa40037, CODE_FOR_ceilsf2 },
  { 0xa40038, CODE_FOR_ceildf2 },
  { 0xa40039, CODE_FOR_ceiltf2 },
  { 0xa4003b, CODE_FOR_ceildd2 },
  { 0xa4003c, CODE_FOR_ceiltd2 },
  { 0xa50037, CODE_FOR_btruncsf2 },
  { 0xa50038, CODE_FOR_btruncdf2 },
  { 0xa50039, CODE_FOR_btrunctf2 },
  { 0xa5003b, CODE_FOR_btruncdd2 },
  { 0xa5003c, CODE_FOR_btrunctd2 },
  { 0xa60037, CODE_FOR_nearbyintsf2 },
  { 0xa60038, CODE_FOR_nearbyintdf2 },
  { 0xa60039, CODE_FOR_nearbyinttf2 },
  { 0xa6003b, CODE_FOR_nearbyintdd2 },
  { 0xa6003c, CODE_FOR_nearbyinttd2 },
  { 0xab0037, CODE_FOR_copysignsf3 },
  { 0xab0038, CODE_FOR_copysigndf3 },
  { 0xab0039, CODE_FOR_copysigntf3 },
  { 0xab003b, CODE_FOR_copysigndd3 },
  { 0xab003c, CODE_FOR_copysigntd3 },
  { 0xb30037, CODE_FOR_isinfsf2 },
  { 0xb30038, CODE_FOR_isinfdf2 },
  { 0xb30039, CODE_FOR_isinftf2 },
  { 0xb3003a, CODE_FOR_isinfsd2 },
  { 0xb3003b, CODE_FOR_isinfdd2 },
  { 0xb3003c, CODE_FOR_isinftd2 },
  { 0xbe0037, CODE_FOR_signbitsf2 },
  { 0xbe0038, CODE_FOR_signbitdf2 },
  { 0xbe0039, CODE_FOR_signbittf2 },
  { 0xbe003a, CODE_FOR_signbitsd2 },
  { 0xbe003b, CODE_FOR_signbitdd2 },
  { 0xbe003c, CODE_FOR_signbittd2 },
  { 0xd00046, CODE_FOR_vec_extractv1qi },
  { 0xd00047, CODE_FOR_vec_extractv2qi },
  { 0xd00048, CODE_FOR_vec_extractv1hi },
  { 0xd00049, CODE_FOR_vec_extractv4qi },
  { 0xd0004a, CODE_FOR_vec_extractv2hi },
  { 0xd0004b, CODE_FOR_vec_extractv1si },
  { 0xd0004c, CODE_FOR_vec_extractv8qi },
  { 0xd0004d, CODE_FOR_vec_extractv4hi },
  { 0xd0004e, CODE_FOR_vec_extractv2si },
  { 0xd0004f, CODE_FOR_vec_extractv1di },
  { 0xd00050, CODE_FOR_vec_extractv16qi },
  { 0xd00051, CODE_FOR_vec_extractv8hi },
  { 0xd00052, CODE_FOR_vec_extractv4si },
  { 0xd00053, CODE_FOR_vec_extractv2di },
  { 0xd00055, CODE_FOR_vec_extractv1sf },
  { 0xd00056, CODE_FOR_vec_extractv2sf },
  { 0xd00057, CODE_FOR_vec_extractv1df },
  { 0xd00058, CODE_FOR_vec_extractv4sf },
  { 0xd00059, CODE_FOR_vec_extractv2df },
  { 0xd10050, CODE_FOR_vec_initv16qi },
  { 0xd10051, CODE_FOR_vec_initv8hi },
  { 0xd10052, CODE_FOR_vec_initv4si },
  { 0xd10053, CODE_FOR_vec_initv2di },
  { 0xd10054, CODE_FOR_vec_initv1ti },
  { 0xd10058, CODE_FOR_vec_initv4sf },
  { 0xd10059, CODE_FOR_vec_initv2df },
  { 0xd1005a, CODE_FOR_vec_initv1tf },
  { 0xd30051, CODE_FOR_vec_pack_ssat_v8hi },
  { 0xd30052, CODE_FOR_vec_pack_ssat_v4si },
  { 0xd30053, CODE_FOR_vec_pack_ssat_v2di },
  { 0xd40051, CODE_FOR_vec_pack_trunc_v8hi },
  { 0xd40052, CODE_FOR_vec_pack_trunc_v4si },
  { 0xd40053, CODE_FOR_vec_pack_trunc_v2di },
  { 0xd60051, CODE_FOR_vec_pack_usat_v8hi },
  { 0xd60052, CODE_FOR_vec_pack_usat_v4si },
  { 0xd60053, CODE_FOR_vec_pack_usat_v2di },
  { 0xd80050, CODE_FOR_vec_permv16qi },
  { 0xda0046, CODE_FOR_vec_setv1qi },
  { 0xda0047, CODE_FOR_vec_setv2qi },
  { 0xda0048, CODE_FOR_vec_setv1hi },
  { 0xda0049, CODE_FOR_vec_setv4qi },
  { 0xda004a, CODE_FOR_vec_setv2hi },
  { 0xda004b, CODE_FOR_vec_setv1si },
  { 0xda004c, CODE_FOR_vec_setv8qi },
  { 0xda004d, CODE_FOR_vec_setv4hi },
  { 0xda004e, CODE_FOR_vec_setv2si },
  { 0xda004f, CODE_FOR_vec_setv1di },
  { 0xda0050, CODE_FOR_vec_setv16qi },
  { 0xda0051, CODE_FOR_vec_setv8hi },
  { 0xda0052, CODE_FOR_vec_setv4si },
  { 0xda0053, CODE_FOR_vec_setv2di },
  { 0xda0055, CODE_FOR_vec_setv1sf },
  { 0xda0056, CODE_FOR_vec_setv2sf },
  { 0xda0057, CODE_FOR_vec_setv1df },
  { 0xda0058, CODE_FOR_vec_setv4sf },
  { 0xda0059, CODE_FOR_vec_setv2df },
  { 0xde0050, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0xde0051, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0xde0052, CODE_FOR_vec_unpacks_hi_v4si },
  { 0xdf0051, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0xdf0052, CODE_FOR_vec_unpacks_lo_v4si },
  { 0xe20050, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0xe20051, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0xe20052, CODE_FOR_vec_unpacku_hi_v4si },
  { 0xe30051, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0xe30052, CODE_FOR_vec_unpacku_lo_v4si },
  { 0xe40046, CODE_FOR_vec_widen_smult_even_v1qi },
  { 0xe40047, CODE_FOR_vec_widen_smult_even_v2qi },
  { 0xe40048, CODE_FOR_vec_widen_smult_even_v1hi },
  { 0xe40049, CODE_FOR_vec_widen_smult_even_v4qi },
  { 0xe4004a, CODE_FOR_vec_widen_smult_even_v2hi },
  { 0xe4004b, CODE_FOR_vec_widen_smult_even_v1si },
  { 0xe4004c, CODE_FOR_vec_widen_smult_even_v8qi },
  { 0xe4004d, CODE_FOR_vec_widen_smult_even_v4hi },
  { 0xe4004e, CODE_FOR_vec_widen_smult_even_v2si },
  { 0xe40050, CODE_FOR_vec_widen_smult_even_v16qi },
  { 0xe40051, CODE_FOR_vec_widen_smult_even_v8hi },
  { 0xe40052, CODE_FOR_vec_widen_smult_even_v4si },
  { 0xe70046, CODE_FOR_vec_widen_smult_odd_v1qi },
  { 0xe70047, CODE_FOR_vec_widen_smult_odd_v2qi },
  { 0xe70048, CODE_FOR_vec_widen_smult_odd_v1hi },
  { 0xe70049, CODE_FOR_vec_widen_smult_odd_v4qi },
  { 0xe7004a, CODE_FOR_vec_widen_smult_odd_v2hi },
  { 0xe7004b, CODE_FOR_vec_widen_smult_odd_v1si },
  { 0xe7004c, CODE_FOR_vec_widen_smult_odd_v8qi },
  { 0xe7004d, CODE_FOR_vec_widen_smult_odd_v4hi },
  { 0xe7004e, CODE_FOR_vec_widen_smult_odd_v2si },
  { 0xe70050, CODE_FOR_vec_widen_smult_odd_v16qi },
  { 0xe70051, CODE_FOR_vec_widen_smult_odd_v8hi },
  { 0xe70052, CODE_FOR_vec_widen_smult_odd_v4si },
  { 0xea0046, CODE_FOR_vec_widen_umult_even_v1qi },
  { 0xea0047, CODE_FOR_vec_widen_umult_even_v2qi },
  { 0xea0048, CODE_FOR_vec_widen_umult_even_v1hi },
  { 0xea0049, CODE_FOR_vec_widen_umult_even_v4qi },
  { 0xea004a, CODE_FOR_vec_widen_umult_even_v2hi },
  { 0xea004b, CODE_FOR_vec_widen_umult_even_v1si },
  { 0xea004c, CODE_FOR_vec_widen_umult_even_v8qi },
  { 0xea004d, CODE_FOR_vec_widen_umult_even_v4hi },
  { 0xea004e, CODE_FOR_vec_widen_umult_even_v2si },
  { 0xea0050, CODE_FOR_vec_widen_umult_even_v16qi },
  { 0xea0051, CODE_FOR_vec_widen_umult_even_v8hi },
  { 0xea0052, CODE_FOR_vec_widen_umult_even_v4si },
  { 0xed0046, CODE_FOR_vec_widen_umult_odd_v1qi },
  { 0xed0047, CODE_FOR_vec_widen_umult_odd_v2qi },
  { 0xed0048, CODE_FOR_vec_widen_umult_odd_v1hi },
  { 0xed0049, CODE_FOR_vec_widen_umult_odd_v4qi },
  { 0xed004a, CODE_FOR_vec_widen_umult_odd_v2hi },
  { 0xed004b, CODE_FOR_vec_widen_umult_odd_v1si },
  { 0xed004c, CODE_FOR_vec_widen_umult_odd_v8qi },
  { 0xed004d, CODE_FOR_vec_widen_umult_odd_v4hi },
  { 0xed004e, CODE_FOR_vec_widen_umult_odd_v2si },
  { 0xed0050, CODE_FOR_vec_widen_umult_odd_v16qi },
  { 0xed0051, CODE_FOR_vec_widen_umult_odd_v8hi },
  { 0xed0052, CODE_FOR_vec_widen_umult_odd_v4si },
  { 0xf7001f, CODE_FOR_atomic_add_fetchqi },
  { 0xf70020, CODE_FOR_atomic_add_fetchhi },
  { 0xf8001f, CODE_FOR_atomic_addqi },
  { 0xf80020, CODE_FOR_atomic_addhi },
  { 0xf9001f, CODE_FOR_atomic_and_fetchqi },
  { 0xf90020, CODE_FOR_atomic_and_fetchhi },
  { 0xfa001f, CODE_FOR_atomic_andqi },
  { 0xfa0020, CODE_FOR_atomic_andhi },
  { 0xfe001f, CODE_FOR_atomic_compare_and_swapqi },
  { 0xfe0020, CODE_FOR_atomic_compare_and_swaphi },
  { 0xfe0021, CODE_FOR_atomic_compare_and_swapsi },
  { 0xfe0022, CODE_FOR_atomic_compare_and_swapdi },
  { 0xfe0023, CODE_FOR_atomic_compare_and_swapti },
  { 0xff001f, CODE_FOR_atomic_exchangeqi },
  { 0xff0020, CODE_FOR_atomic_exchangehi },
  { 0xff0021, CODE_FOR_atomic_exchangesi },
  { 0xff0022, CODE_FOR_atomic_exchangedi },
  { 0xff0023, CODE_FOR_atomic_exchangeti },
  { 0x100001f, CODE_FOR_atomic_fetch_addqi },
  { 0x1000020, CODE_FOR_atomic_fetch_addhi },
  { 0x1000021, CODE_FOR_atomic_fetch_addsi },
  { 0x1000022, CODE_FOR_atomic_fetch_adddi },
  { 0x101001f, CODE_FOR_atomic_fetch_andqi },
  { 0x1010020, CODE_FOR_atomic_fetch_andhi },
  { 0x1010021, CODE_FOR_atomic_fetch_andsi },
  { 0x1010022, CODE_FOR_atomic_fetch_anddi },
  { 0x102001f, CODE_FOR_atomic_fetch_nandqi },
  { 0x1020020, CODE_FOR_atomic_fetch_nandhi },
  { 0x103001f, CODE_FOR_atomic_fetch_orqi },
  { 0x1030020, CODE_FOR_atomic_fetch_orhi },
  { 0x1030021, CODE_FOR_atomic_fetch_orsi },
  { 0x1030022, CODE_FOR_atomic_fetch_ordi },
  { 0x104001f, CODE_FOR_atomic_fetch_subqi },
  { 0x1040020, CODE_FOR_atomic_fetch_subhi },
  { 0x105001f, CODE_FOR_atomic_fetch_xorqi },
  { 0x1050020, CODE_FOR_atomic_fetch_xorhi },
  { 0x1050021, CODE_FOR_atomic_fetch_xorsi },
  { 0x1050022, CODE_FOR_atomic_fetch_xordi },
  { 0x106001f, CODE_FOR_atomic_loadqi },
  { 0x1060020, CODE_FOR_atomic_loadhi },
  { 0x1060021, CODE_FOR_atomic_loadsi },
  { 0x1060022, CODE_FOR_atomic_loaddi },
  { 0x1060023, CODE_FOR_atomic_loadti },
  { 0x107001f, CODE_FOR_atomic_nand_fetchqi },
  { 0x1070020, CODE_FOR_atomic_nand_fetchhi },
  { 0x108001f, CODE_FOR_atomic_nandqi },
  { 0x1080020, CODE_FOR_atomic_nandhi },
  { 0x109001f, CODE_FOR_atomic_or_fetchqi },
  { 0x1090020, CODE_FOR_atomic_or_fetchhi },
  { 0x10a001f, CODE_FOR_atomic_orqi },
  { 0x10a0020, CODE_FOR_atomic_orhi },
  { 0x10b001f, CODE_FOR_atomic_storeqi },
  { 0x10b0020, CODE_FOR_atomic_storehi },
  { 0x10b0021, CODE_FOR_atomic_storesi },
  { 0x10b0022, CODE_FOR_atomic_storedi },
  { 0x10b0023, CODE_FOR_atomic_storeti },
  { 0x10c001f, CODE_FOR_atomic_sub_fetchqi },
  { 0x10c0020, CODE_FOR_atomic_sub_fetchhi },
  { 0x10d001f, CODE_FOR_atomic_subqi },
  { 0x10d0020, CODE_FOR_atomic_subhi },
  { 0x10e001f, CODE_FOR_atomic_xor_fetchqi },
  { 0x10e0020, CODE_FOR_atomic_xor_fetchhi },
  { 0x10f001f, CODE_FOR_atomic_xorqi },
  { 0x10f0020, CODE_FOR_atomic_xorhi },
  { 0x1100021, CODE_FOR_get_thread_pointersi },
  { 0x1100022, CODE_FOR_get_thread_pointerdi },
  { 0x1110021, CODE_FOR_set_thread_pointersi },
  { 0x1110022, CODE_FOR_set_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqisi2;
  ena[1] = HAVE_extendqidi2;
  ena[2] = HAVE_extendhisi2;
  ena[3] = HAVE_extendhidi2;
  ena[4] = HAVE_extendsidi2;
  ena[5] = HAVE_extendsfdf2;
  ena[6] = HAVE_extendsftf2;
  ena[7] = HAVE_extendsfsd2;
  ena[8] = HAVE_extendsfdd2;
  ena[9] = HAVE_extendsftd2;
  ena[10] = HAVE_extenddfsf2;
  ena[11] = HAVE_extenddftf2;
  ena[12] = HAVE_extenddfsd2;
  ena[13] = HAVE_extenddfdd2;
  ena[14] = HAVE_extenddftd2;
  ena[15] = HAVE_extendtfsd2;
  ena[16] = HAVE_extendtfdd2;
  ena[17] = HAVE_extendtftd2;
  ena[18] = HAVE_extendsdsf2;
  ena[19] = HAVE_extendsddf2;
  ena[20] = HAVE_extendsdtf2;
  ena[21] = HAVE_extendsddd2;
  ena[22] = HAVE_extendsdtd2;
  ena[23] = HAVE_extendddsf2;
  ena[24] = HAVE_extenddddf2;
  ena[25] = HAVE_extendddtf2;
  ena[26] = HAVE_extendddtd2;
  ena[27] = HAVE_extendtdsf2;
  ena[28] = HAVE_extendtddf2;
  ena[29] = HAVE_extendtdtf2;
  ena[30] = HAVE_truncsfsd2;
  ena[31] = HAVE_truncsfdd2;
  ena[32] = HAVE_truncsftd2;
  ena[33] = HAVE_truncdfsf2;
  ena[34] = HAVE_truncdfsd2;
  ena[35] = HAVE_truncdfdd2;
  ena[36] = HAVE_truncdftd2;
  ena[37] = HAVE_trunctfsf2;
  ena[38] = HAVE_trunctfdf2;
  ena[39] = HAVE_trunctfsd2;
  ena[40] = HAVE_trunctfdd2;
  ena[41] = HAVE_trunctftd2;
  ena[42] = HAVE_truncsdsf2;
  ena[43] = HAVE_truncsddf2;
  ena[44] = HAVE_truncsdtf2;
  ena[45] = HAVE_truncddsf2;
  ena[46] = HAVE_truncdddf2;
  ena[47] = HAVE_truncddtf2;
  ena[48] = HAVE_truncddsd2;
  ena[49] = HAVE_trunctdsf2;
  ena[50] = HAVE_trunctddf2;
  ena[51] = HAVE_trunctdtf2;
  ena[52] = HAVE_trunctdsd2;
  ena[53] = HAVE_trunctddd2;
  ena[54] = HAVE_zero_extendqihi2;
  ena[55] = HAVE_zero_extendqisi2;
  ena[56] = HAVE_zero_extendqidi2;
  ena[57] = HAVE_zero_extendhisi2;
  ena[58] = HAVE_zero_extendhidi2;
  ena[59] = HAVE_zero_extendsidi2;
  ena[60] = HAVE_floatsisf2;
  ena[61] = HAVE_floatsidf2;
  ena[62] = HAVE_floatsitf2;
  ena[63] = HAVE_floatsidd2;
  ena[64] = HAVE_floatsitd2;
  ena[65] = HAVE_floatdisf2;
  ena[66] = HAVE_floatdidf2;
  ena[67] = HAVE_floatditf2;
  ena[68] = HAVE_floatdidd2;
  ena[69] = HAVE_floatditd2;
  ena[70] = HAVE_floatunssisf2;
  ena[71] = HAVE_floatunssidf2;
  ena[72] = HAVE_floatunssitf2;
  ena[73] = HAVE_floatunssidd2;
  ena[74] = HAVE_floatunssitd2;
  ena[75] = HAVE_floatunsdisf2;
  ena[76] = HAVE_floatunsdidf2;
  ena[77] = HAVE_floatunsditf2;
  ena[78] = HAVE_floatunsdidd2;
  ena[79] = HAVE_floatunsditd2;
  ena[80] = HAVE_fix_truncsfsi2;
  ena[81] = HAVE_fix_truncsfdi2;
  ena[82] = HAVE_fix_truncdfsi2;
  ena[83] = HAVE_fix_truncdfdi2;
  ena[84] = HAVE_fix_trunctfsi2;
  ena[85] = HAVE_fix_trunctfdi2;
  ena[86] = HAVE_fix_truncdddi2;
  ena[87] = HAVE_fix_trunctddi2;
  ena[88] = HAVE_fixuns_truncsfsi2;
  ena[89] = HAVE_fixuns_truncsfdi2;
  ena[90] = HAVE_fixuns_truncdfsi2;
  ena[91] = HAVE_fixuns_truncdfdi2;
  ena[92] = HAVE_fixuns_trunctfsi2;
  ena[93] = HAVE_fixuns_trunctfdi2;
  ena[94] = HAVE_fixuns_truncddsi2;
  ena[95] = HAVE_fixuns_truncdddi2;
  ena[96] = HAVE_fixuns_trunctdsi2;
  ena[97] = HAVE_fixuns_trunctddi2;
  ena[98] = HAVE_mulsidi3;
  ena[99] = HAVE_mulditi3;
  ena[100] = HAVE_umulsidi3;
  ena[101] = HAVE_umulditi3;
  ena[102] = HAVE_vcondv16qiv16qi;
  ena[103] = HAVE_vcondv8hiv16qi;
  ena[104] = HAVE_vcondv4siv16qi;
  ena[105] = HAVE_vcondv2div16qi;
  ena[106] = HAVE_vcondv4sfv16qi;
  ena[107] = HAVE_vcondv2dfv16qi;
  ena[108] = HAVE_vcondv1tfv16qi;
  ena[109] = HAVE_vcondv16qiv8hi;
  ena[110] = HAVE_vcondv8hiv8hi;
  ena[111] = HAVE_vcondv4siv8hi;
  ena[112] = HAVE_vcondv2div8hi;
  ena[113] = HAVE_vcondv4sfv8hi;
  ena[114] = HAVE_vcondv2dfv8hi;
  ena[115] = HAVE_vcondv1tfv8hi;
  ena[116] = HAVE_vcondv16qiv4si;
  ena[117] = HAVE_vcondv8hiv4si;
  ena[118] = HAVE_vcondv4siv4si;
  ena[119] = HAVE_vcondv2div4si;
  ena[120] = HAVE_vcondv4sfv4si;
  ena[121] = HAVE_vcondv2dfv4si;
  ena[122] = HAVE_vcondv1tfv4si;
  ena[123] = HAVE_vcondv16qiv2di;
  ena[124] = HAVE_vcondv8hiv2di;
  ena[125] = HAVE_vcondv4siv2di;
  ena[126] = HAVE_vcondv2div2di;
  ena[127] = HAVE_vcondv4sfv2di;
  ena[128] = HAVE_vcondv2dfv2di;
  ena[129] = HAVE_vcondv1tfv2di;
  ena[130] = HAVE_vcondv16qiv4sf;
  ena[131] = HAVE_vcondv8hiv4sf;
  ena[132] = HAVE_vcondv4siv4sf;
  ena[133] = HAVE_vcondv2div4sf;
  ena[134] = HAVE_vcondv4sfv4sf;
  ena[135] = HAVE_vcondv2dfv4sf;
  ena[136] = HAVE_vcondv1tfv4sf;
  ena[137] = HAVE_vcondv16qiv2df;
  ena[138] = HAVE_vcondv8hiv2df;
  ena[139] = HAVE_vcondv4siv2df;
  ena[140] = HAVE_vcondv2div2df;
  ena[141] = HAVE_vcondv4sfv2df;
  ena[142] = HAVE_vcondv2dfv2df;
  ena[143] = HAVE_vcondv1tfv2df;
  ena[144] = HAVE_vcondv16qiv1tf;
  ena[145] = HAVE_vcondv8hiv1tf;
  ena[146] = HAVE_vcondv4siv1tf;
  ena[147] = HAVE_vcondv2div1tf;
  ena[148] = HAVE_vcondv4sfv1tf;
  ena[149] = HAVE_vcondv2dfv1tf;
  ena[150] = HAVE_vcondv1tfv1tf;
  ena[151] = HAVE_vconduv16qiv16qi;
  ena[152] = HAVE_vconduv8hiv16qi;
  ena[153] = HAVE_vconduv4siv16qi;
  ena[154] = HAVE_vconduv2div16qi;
  ena[155] = HAVE_vconduv4sfv16qi;
  ena[156] = HAVE_vconduv2dfv16qi;
  ena[157] = HAVE_vconduv1tfv16qi;
  ena[158] = HAVE_vconduv16qiv8hi;
  ena[159] = HAVE_vconduv8hiv8hi;
  ena[160] = HAVE_vconduv4siv8hi;
  ena[161] = HAVE_vconduv2div8hi;
  ena[162] = HAVE_vconduv4sfv8hi;
  ena[163] = HAVE_vconduv2dfv8hi;
  ena[164] = HAVE_vconduv1tfv8hi;
  ena[165] = HAVE_vconduv16qiv4si;
  ena[166] = HAVE_vconduv8hiv4si;
  ena[167] = HAVE_vconduv4siv4si;
  ena[168] = HAVE_vconduv2div4si;
  ena[169] = HAVE_vconduv4sfv4si;
  ena[170] = HAVE_vconduv2dfv4si;
  ena[171] = HAVE_vconduv1tfv4si;
  ena[172] = HAVE_vconduv16qiv2di;
  ena[173] = HAVE_vconduv8hiv2di;
  ena[174] = HAVE_vconduv4siv2di;
  ena[175] = HAVE_vconduv2div2di;
  ena[176] = HAVE_vconduv4sfv2di;
  ena[177] = HAVE_vconduv2dfv2di;
  ena[178] = HAVE_vconduv1tfv2di;
  ena[179] = HAVE_vconduv16qiv4sf;
  ena[180] = HAVE_vconduv8hiv4sf;
  ena[181] = HAVE_vconduv4siv4sf;
  ena[182] = HAVE_vconduv2div4sf;
  ena[183] = HAVE_vconduv4sfv4sf;
  ena[184] = HAVE_vconduv2dfv4sf;
  ena[185] = HAVE_vconduv1tfv4sf;
  ena[186] = HAVE_vconduv16qiv2df;
  ena[187] = HAVE_vconduv8hiv2df;
  ena[188] = HAVE_vconduv4siv2df;
  ena[189] = HAVE_vconduv2div2df;
  ena[190] = HAVE_vconduv4sfv2df;
  ena[191] = HAVE_vconduv2dfv2df;
  ena[192] = HAVE_vconduv1tfv2df;
  ena[193] = HAVE_vconduv16qiv1tf;
  ena[194] = HAVE_vconduv8hiv1tf;
  ena[195] = HAVE_vconduv4siv1tf;
  ena[196] = HAVE_vconduv2div1tf;
  ena[197] = HAVE_vconduv4sfv1tf;
  ena[198] = HAVE_vconduv2dfv1tf;
  ena[199] = HAVE_vconduv1tfv1tf;
  ena[200] = HAVE_addsi3;
  ena[201] = HAVE_adddi3;
  ena[202] = HAVE_addti3;
  ena[203] = HAVE_addsf3;
  ena[204] = HAVE_adddf3;
  ena[205] = HAVE_addtf3;
  ena[206] = HAVE_adddd3;
  ena[207] = HAVE_addtd3;
  ena[208] = HAVE_addv1qi3;
  ena[209] = HAVE_addv2qi3;
  ena[210] = HAVE_addv1hi3;
  ena[211] = HAVE_addv4qi3;
  ena[212] = HAVE_addv2hi3;
  ena[213] = HAVE_addv1si3;
  ena[214] = HAVE_addv8qi3;
  ena[215] = HAVE_addv4hi3;
  ena[216] = HAVE_addv2si3;
  ena[217] = HAVE_addv1di3;
  ena[218] = HAVE_addv16qi3;
  ena[219] = HAVE_addv8hi3;
  ena[220] = HAVE_addv4si3;
  ena[221] = HAVE_addv2di3;
  ena[222] = HAVE_addv1ti3;
  ena[223] = HAVE_addv4sf3;
  ena[224] = HAVE_addv2df3;
  ena[225] = HAVE_addv1tf3;
  ena[226] = HAVE_subsi3;
  ena[227] = HAVE_subdi3;
  ena[228] = HAVE_subti3;
  ena[229] = HAVE_subsf3;
  ena[230] = HAVE_subdf3;
  ena[231] = HAVE_subtf3;
  ena[232] = HAVE_subdd3;
  ena[233] = HAVE_subtd3;
  ena[234] = HAVE_subv1qi3;
  ena[235] = HAVE_subv2qi3;
  ena[236] = HAVE_subv1hi3;
  ena[237] = HAVE_subv4qi3;
  ena[238] = HAVE_subv2hi3;
  ena[239] = HAVE_subv1si3;
  ena[240] = HAVE_subv8qi3;
  ena[241] = HAVE_subv4hi3;
  ena[242] = HAVE_subv2si3;
  ena[243] = HAVE_subv1di3;
  ena[244] = HAVE_subv16qi3;
  ena[245] = HAVE_subv8hi3;
  ena[246] = HAVE_subv4si3;
  ena[247] = HAVE_subv2di3;
  ena[248] = HAVE_subv1ti3;
  ena[249] = HAVE_subv4sf3;
  ena[250] = HAVE_subv2df3;
  ena[251] = HAVE_subv1tf3;
  ena[252] = HAVE_mulsi3;
  ena[253] = HAVE_muldi3;
  ena[254] = HAVE_mulsf3;
  ena[255] = HAVE_muldf3;
  ena[256] = HAVE_multf3;
  ena[257] = HAVE_muldd3;
  ena[258] = HAVE_multd3;
  ena[259] = HAVE_mulv1qi3;
  ena[260] = HAVE_mulv2qi3;
  ena[261] = HAVE_mulv1hi3;
  ena[262] = HAVE_mulv4qi3;
  ena[263] = HAVE_mulv2hi3;
  ena[264] = HAVE_mulv1si3;
  ena[265] = HAVE_mulv8qi3;
  ena[266] = HAVE_mulv4hi3;
  ena[267] = HAVE_mulv2si3;
  ena[268] = HAVE_mulv16qi3;
  ena[269] = HAVE_mulv8hi3;
  ena[270] = HAVE_mulv4si3;
  ena[271] = HAVE_mulv4sf3;
  ena[272] = HAVE_mulv2df3;
  ena[273] = HAVE_mulv1tf3;
  ena[274] = HAVE_divsf3;
  ena[275] = HAVE_divdf3;
  ena[276] = HAVE_divtf3;
  ena[277] = HAVE_divdd3;
  ena[278] = HAVE_divtd3;
  ena[279] = HAVE_divv4sf3;
  ena[280] = HAVE_divv2df3;
  ena[281] = HAVE_divv1tf3;
  ena[282] = HAVE_udivsi3;
  ena[283] = HAVE_divmodsi4;
  ena[284] = HAVE_divmoddi4;
  ena[285] = HAVE_udivmodsi4;
  ena[286] = HAVE_udivmoddi4;
  ena[287] = HAVE_umodsi3;
  ena[288] = HAVE_andqi3;
  ena[289] = HAVE_andhi3;
  ena[290] = HAVE_andsi3;
  ena[291] = HAVE_anddi3;
  ena[292] = HAVE_andti3;
  ena[293] = HAVE_andv1qi3;
  ena[294] = HAVE_andv2qi3;
  ena[295] = HAVE_andv1hi3;
  ena[296] = HAVE_andv4qi3;
  ena[297] = HAVE_andv2hi3;
  ena[298] = HAVE_andv1si3;
  ena[299] = HAVE_andv8qi3;
  ena[300] = HAVE_andv4hi3;
  ena[301] = HAVE_andv2si3;
  ena[302] = HAVE_andv1di3;
  ena[303] = HAVE_andv16qi3;
  ena[304] = HAVE_andv8hi3;
  ena[305] = HAVE_andv4si3;
  ena[306] = HAVE_andv2di3;
  ena[307] = HAVE_andv1ti3;
  ena[308] = HAVE_andv1sf3;
  ena[309] = HAVE_andv2sf3;
  ena[310] = HAVE_andv1df3;
  ena[311] = HAVE_andv4sf3;
  ena[312] = HAVE_andv2df3;
  ena[313] = HAVE_andv1tf3;
  ena[314] = HAVE_iorqi3;
  ena[315] = HAVE_iorhi3;
  ena[316] = HAVE_iorsi3;
  ena[317] = HAVE_iordi3;
  ena[318] = HAVE_iorti3;
  ena[319] = HAVE_iorv1qi3;
  ena[320] = HAVE_iorv2qi3;
  ena[321] = HAVE_iorv1hi3;
  ena[322] = HAVE_iorv4qi3;
  ena[323] = HAVE_iorv2hi3;
  ena[324] = HAVE_iorv1si3;
  ena[325] = HAVE_iorv8qi3;
  ena[326] = HAVE_iorv4hi3;
  ena[327] = HAVE_iorv2si3;
  ena[328] = HAVE_iorv1di3;
  ena[329] = HAVE_iorv16qi3;
  ena[330] = HAVE_iorv8hi3;
  ena[331] = HAVE_iorv4si3;
  ena[332] = HAVE_iorv2di3;
  ena[333] = HAVE_iorv1ti3;
  ena[334] = HAVE_iorv1sf3;
  ena[335] = HAVE_iorv2sf3;
  ena[336] = HAVE_iorv1df3;
  ena[337] = HAVE_iorv4sf3;
  ena[338] = HAVE_iorv2df3;
  ena[339] = HAVE_iorv1tf3;
  ena[340] = HAVE_xorqi3;
  ena[341] = HAVE_xorhi3;
  ena[342] = HAVE_xorsi3;
  ena[343] = HAVE_xordi3;
  ena[344] = HAVE_xorti3;
  ena[345] = HAVE_xorv1qi3;
  ena[346] = HAVE_xorv2qi3;
  ena[347] = HAVE_xorv1hi3;
  ena[348] = HAVE_xorv4qi3;
  ena[349] = HAVE_xorv2hi3;
  ena[350] = HAVE_xorv1si3;
  ena[351] = HAVE_xorv8qi3;
  ena[352] = HAVE_xorv4hi3;
  ena[353] = HAVE_xorv2si3;
  ena[354] = HAVE_xorv1di3;
  ena[355] = HAVE_xorv16qi3;
  ena[356] = HAVE_xorv8hi3;
  ena[357] = HAVE_xorv4si3;
  ena[358] = HAVE_xorv2di3;
  ena[359] = HAVE_xorv1ti3;
  ena[360] = HAVE_xorv1sf3;
  ena[361] = HAVE_xorv2sf3;
  ena[362] = HAVE_xorv1df3;
  ena[363] = HAVE_xorv4sf3;
  ena[364] = HAVE_xorv2df3;
  ena[365] = HAVE_xorv1tf3;
  ena[366] = HAVE_ashlsi3;
  ena[367] = HAVE_ashldi3;
  ena[368] = HAVE_ashlv1qi3;
  ena[369] = HAVE_ashlv2qi3;
  ena[370] = HAVE_ashlv1hi3;
  ena[371] = HAVE_ashlv4qi3;
  ena[372] = HAVE_ashlv2hi3;
  ena[373] = HAVE_ashlv1si3;
  ena[374] = HAVE_ashlv8qi3;
  ena[375] = HAVE_ashlv4hi3;
  ena[376] = HAVE_ashlv2si3;
  ena[377] = HAVE_ashlv1di3;
  ena[378] = HAVE_ashlv16qi3;
  ena[379] = HAVE_ashlv8hi3;
  ena[380] = HAVE_ashlv4si3;
  ena[381] = HAVE_ashlv2di3;
  ena[382] = HAVE_ashrsi3;
  ena[383] = HAVE_ashrdi3;
  ena[384] = HAVE_ashrv1qi3;
  ena[385] = HAVE_ashrv2qi3;
  ena[386] = HAVE_ashrv1hi3;
  ena[387] = HAVE_ashrv4qi3;
  ena[388] = HAVE_ashrv2hi3;
  ena[389] = HAVE_ashrv1si3;
  ena[390] = HAVE_ashrv8qi3;
  ena[391] = HAVE_ashrv4hi3;
  ena[392] = HAVE_ashrv2si3;
  ena[393] = HAVE_ashrv1di3;
  ena[394] = HAVE_ashrv16qi3;
  ena[395] = HAVE_ashrv8hi3;
  ena[396] = HAVE_ashrv4si3;
  ena[397] = HAVE_ashrv2di3;
  ena[398] = HAVE_lshrsi3;
  ena[399] = HAVE_lshrdi3;
  ena[400] = HAVE_lshrv1qi3;
  ena[401] = HAVE_lshrv2qi3;
  ena[402] = HAVE_lshrv1hi3;
  ena[403] = HAVE_lshrv4qi3;
  ena[404] = HAVE_lshrv2hi3;
  ena[405] = HAVE_lshrv1si3;
  ena[406] = HAVE_lshrv8qi3;
  ena[407] = HAVE_lshrv4hi3;
  ena[408] = HAVE_lshrv2si3;
  ena[409] = HAVE_lshrv1di3;
  ena[410] = HAVE_lshrv16qi3;
  ena[411] = HAVE_lshrv8hi3;
  ena[412] = HAVE_lshrv4si3;
  ena[413] = HAVE_lshrv2di3;
  ena[414] = HAVE_rotlsi3;
  ena[415] = HAVE_rotldi3;
  ena[416] = HAVE_rotlv1qi3;
  ena[417] = HAVE_rotlv2qi3;
  ena[418] = HAVE_rotlv1hi3;
  ena[419] = HAVE_rotlv4qi3;
  ena[420] = HAVE_rotlv2hi3;
  ena[421] = HAVE_rotlv1si3;
  ena[422] = HAVE_rotlv8qi3;
  ena[423] = HAVE_rotlv4hi3;
  ena[424] = HAVE_rotlv2si3;
  ena[425] = HAVE_rotlv1di3;
  ena[426] = HAVE_rotlv16qi3;
  ena[427] = HAVE_rotlv8hi3;
  ena[428] = HAVE_rotlv4si3;
  ena[429] = HAVE_rotlv2di3;
  ena[430] = HAVE_vashlv1qi3;
  ena[431] = HAVE_vashlv2qi3;
  ena[432] = HAVE_vashlv1hi3;
  ena[433] = HAVE_vashlv4qi3;
  ena[434] = HAVE_vashlv2hi3;
  ena[435] = HAVE_vashlv1si3;
  ena[436] = HAVE_vashlv8qi3;
  ena[437] = HAVE_vashlv4hi3;
  ena[438] = HAVE_vashlv2si3;
  ena[439] = HAVE_vashlv1di3;
  ena[440] = HAVE_vashlv16qi3;
  ena[441] = HAVE_vashlv8hi3;
  ena[442] = HAVE_vashlv4si3;
  ena[443] = HAVE_vashlv2di3;
  ena[444] = HAVE_vashrv1qi3;
  ena[445] = HAVE_vashrv2qi3;
  ena[446] = HAVE_vashrv1hi3;
  ena[447] = HAVE_vashrv4qi3;
  ena[448] = HAVE_vashrv2hi3;
  ena[449] = HAVE_vashrv1si3;
  ena[450] = HAVE_vashrv8qi3;
  ena[451] = HAVE_vashrv4hi3;
  ena[452] = HAVE_vashrv2si3;
  ena[453] = HAVE_vashrv1di3;
  ena[454] = HAVE_vashrv16qi3;
  ena[455] = HAVE_vashrv8hi3;
  ena[456] = HAVE_vashrv4si3;
  ena[457] = HAVE_vashrv2di3;
  ena[458] = HAVE_vlshrv1qi3;
  ena[459] = HAVE_vlshrv2qi3;
  ena[460] = HAVE_vlshrv1hi3;
  ena[461] = HAVE_vlshrv4qi3;
  ena[462] = HAVE_vlshrv2hi3;
  ena[463] = HAVE_vlshrv1si3;
  ena[464] = HAVE_vlshrv8qi3;
  ena[465] = HAVE_vlshrv4hi3;
  ena[466] = HAVE_vlshrv2si3;
  ena[467] = HAVE_vlshrv1di3;
  ena[468] = HAVE_vlshrv16qi3;
  ena[469] = HAVE_vlshrv8hi3;
  ena[470] = HAVE_vlshrv4si3;
  ena[471] = HAVE_vlshrv2di3;
  ena[472] = HAVE_vrotlv1qi3;
  ena[473] = HAVE_vrotlv2qi3;
  ena[474] = HAVE_vrotlv1hi3;
  ena[475] = HAVE_vrotlv4qi3;
  ena[476] = HAVE_vrotlv2hi3;
  ena[477] = HAVE_vrotlv1si3;
  ena[478] = HAVE_vrotlv8qi3;
  ena[479] = HAVE_vrotlv4hi3;
  ena[480] = HAVE_vrotlv2si3;
  ena[481] = HAVE_vrotlv1di3;
  ena[482] = HAVE_vrotlv16qi3;
  ena[483] = HAVE_vrotlv8hi3;
  ena[484] = HAVE_vrotlv4si3;
  ena[485] = HAVE_vrotlv2di3;
  ena[486] = HAVE_sminv1qi3;
  ena[487] = HAVE_sminv2qi3;
  ena[488] = HAVE_sminv1hi3;
  ena[489] = HAVE_sminv4qi3;
  ena[490] = HAVE_sminv2hi3;
  ena[491] = HAVE_sminv1si3;
  ena[492] = HAVE_sminv8qi3;
  ena[493] = HAVE_sminv4hi3;
  ena[494] = HAVE_sminv2si3;
  ena[495] = HAVE_sminv1di3;
  ena[496] = HAVE_sminv16qi3;
  ena[497] = HAVE_sminv8hi3;
  ena[498] = HAVE_sminv4si3;
  ena[499] = HAVE_sminv2di3;
  ena[500] = HAVE_sminv4sf3;
  ena[501] = HAVE_sminv2df3;
  ena[502] = HAVE_sminv1tf3;
  ena[503] = HAVE_smaxv1qi3;
  ena[504] = HAVE_smaxv2qi3;
  ena[505] = HAVE_smaxv1hi3;
  ena[506] = HAVE_smaxv4qi3;
  ena[507] = HAVE_smaxv2hi3;
  ena[508] = HAVE_smaxv1si3;
  ena[509] = HAVE_smaxv8qi3;
  ena[510] = HAVE_smaxv4hi3;
  ena[511] = HAVE_smaxv2si3;
  ena[512] = HAVE_smaxv1di3;
  ena[513] = HAVE_smaxv16qi3;
  ena[514] = HAVE_smaxv8hi3;
  ena[515] = HAVE_smaxv4si3;
  ena[516] = HAVE_smaxv2di3;
  ena[517] = HAVE_smaxv4sf3;
  ena[518] = HAVE_smaxv2df3;
  ena[519] = HAVE_smaxv1tf3;
  ena[520] = HAVE_uminv1qi3;
  ena[521] = HAVE_uminv2qi3;
  ena[522] = HAVE_uminv1hi3;
  ena[523] = HAVE_uminv4qi3;
  ena[524] = HAVE_uminv2hi3;
  ena[525] = HAVE_uminv1si3;
  ena[526] = HAVE_uminv8qi3;
  ena[527] = HAVE_uminv4hi3;
  ena[528] = HAVE_uminv2si3;
  ena[529] = HAVE_uminv1di3;
  ena[530] = HAVE_uminv16qi3;
  ena[531] = HAVE_uminv8hi3;
  ena[532] = HAVE_uminv4si3;
  ena[533] = HAVE_uminv2di3;
  ena[534] = HAVE_umaxv1qi3;
  ena[535] = HAVE_umaxv2qi3;
  ena[536] = HAVE_umaxv1hi3;
  ena[537] = HAVE_umaxv4qi3;
  ena[538] = HAVE_umaxv2hi3;
  ena[539] = HAVE_umaxv1si3;
  ena[540] = HAVE_umaxv8qi3;
  ena[541] = HAVE_umaxv4hi3;
  ena[542] = HAVE_umaxv2si3;
  ena[543] = HAVE_umaxv1di3;
  ena[544] = HAVE_umaxv16qi3;
  ena[545] = HAVE_umaxv8hi3;
  ena[546] = HAVE_umaxv4si3;
  ena[547] = HAVE_umaxv2di3;
  ena[548] = HAVE_negsi2;
  ena[549] = HAVE_negdi2;
  ena[550] = HAVE_negsf2;
  ena[551] = HAVE_negdf2;
  ena[552] = HAVE_negtf2;
  ena[553] = HAVE_negv1qi2;
  ena[554] = HAVE_negv2qi2;
  ena[555] = HAVE_negv1hi2;
  ena[556] = HAVE_negv4qi2;
  ena[557] = HAVE_negv2hi2;
  ena[558] = HAVE_negv1si2;
  ena[559] = HAVE_negv8qi2;
  ena[560] = HAVE_negv4hi2;
  ena[561] = HAVE_negv2si2;
  ena[562] = HAVE_negv1di2;
  ena[563] = HAVE_negv16qi2;
  ena[564] = HAVE_negv8hi2;
  ena[565] = HAVE_negv4si2;
  ena[566] = HAVE_negv2di2;
  ena[567] = HAVE_negv1sf2;
  ena[568] = HAVE_negv2sf2;
  ena[569] = HAVE_negv1df2;
  ena[570] = HAVE_negv4sf2;
  ena[571] = HAVE_negv2df2;
  ena[572] = HAVE_negv1tf2;
  ena[573] = HAVE_abssi2;
  ena[574] = HAVE_absdi2;
  ena[575] = HAVE_abssf2;
  ena[576] = HAVE_absdf2;
  ena[577] = HAVE_abstf2;
  ena[578] = HAVE_absv1qi2;
  ena[579] = HAVE_absv2qi2;
  ena[580] = HAVE_absv1hi2;
  ena[581] = HAVE_absv4qi2;
  ena[582] = HAVE_absv2hi2;
  ena[583] = HAVE_absv1si2;
  ena[584] = HAVE_absv8qi2;
  ena[585] = HAVE_absv4hi2;
  ena[586] = HAVE_absv2si2;
  ena[587] = HAVE_absv1di2;
  ena[588] = HAVE_absv16qi2;
  ena[589] = HAVE_absv8hi2;
  ena[590] = HAVE_absv4si2;
  ena[591] = HAVE_absv2di2;
  ena[592] = HAVE_absv1sf2;
  ena[593] = HAVE_absv2sf2;
  ena[594] = HAVE_absv1df2;
  ena[595] = HAVE_absv4sf2;
  ena[596] = HAVE_absv2df2;
  ena[597] = HAVE_absv1tf2;
  ena[598] = HAVE_one_cmplqi2;
  ena[599] = HAVE_one_cmplhi2;
  ena[600] = HAVE_one_cmplsi2;
  ena[601] = HAVE_one_cmpldi2;
  ena[602] = HAVE_one_cmplti2;
  ena[603] = HAVE_one_cmplv1qi2;
  ena[604] = HAVE_one_cmplv2qi2;
  ena[605] = HAVE_one_cmplv1hi2;
  ena[606] = HAVE_one_cmplv4qi2;
  ena[607] = HAVE_one_cmplv2hi2;
  ena[608] = HAVE_one_cmplv1si2;
  ena[609] = HAVE_one_cmplv8qi2;
  ena[610] = HAVE_one_cmplv4hi2;
  ena[611] = HAVE_one_cmplv2si2;
  ena[612] = HAVE_one_cmplv1di2;
  ena[613] = HAVE_one_cmplv16qi2;
  ena[614] = HAVE_one_cmplv8hi2;
  ena[615] = HAVE_one_cmplv4si2;
  ena[616] = HAVE_one_cmplv2di2;
  ena[617] = HAVE_one_cmplv1ti2;
  ena[618] = HAVE_one_cmplv1sf2;
  ena[619] = HAVE_one_cmplv2sf2;
  ena[620] = HAVE_one_cmplv1df2;
  ena[621] = HAVE_one_cmplv4sf2;
  ena[622] = HAVE_one_cmplv2df2;
  ena[623] = HAVE_one_cmplv1tf2;
  ena[624] = HAVE_bswaphi2;
  ena[625] = HAVE_bswapsi2;
  ena[626] = HAVE_bswapdi2;
  ena[627] = HAVE_clzdi2;
  ena[628] = HAVE_clzv1qi2;
  ena[629] = HAVE_clzv2qi2;
  ena[630] = HAVE_clzv1hi2;
  ena[631] = HAVE_clzv4qi2;
  ena[632] = HAVE_clzv2hi2;
  ena[633] = HAVE_clzv1si2;
  ena[634] = HAVE_clzv8qi2;
  ena[635] = HAVE_clzv4hi2;
  ena[636] = HAVE_clzv2si2;
  ena[637] = HAVE_clzv1di2;
  ena[638] = HAVE_clzv16qi2;
  ena[639] = HAVE_clzv8hi2;
  ena[640] = HAVE_clzv4si2;
  ena[641] = HAVE_clzv2di2;
  ena[642] = HAVE_clzv1sf2;
  ena[643] = HAVE_clzv2sf2;
  ena[644] = HAVE_clzv1df2;
  ena[645] = HAVE_clzv4sf2;
  ena[646] = HAVE_clzv2df2;
  ena[647] = HAVE_ctzv1qi2;
  ena[648] = HAVE_ctzv2qi2;
  ena[649] = HAVE_ctzv1hi2;
  ena[650] = HAVE_ctzv4qi2;
  ena[651] = HAVE_ctzv2hi2;
  ena[652] = HAVE_ctzv1si2;
  ena[653] = HAVE_ctzv8qi2;
  ena[654] = HAVE_ctzv4hi2;
  ena[655] = HAVE_ctzv2si2;
  ena[656] = HAVE_ctzv1di2;
  ena[657] = HAVE_ctzv16qi2;
  ena[658] = HAVE_ctzv8hi2;
  ena[659] = HAVE_ctzv4si2;
  ena[660] = HAVE_ctzv2di2;
  ena[661] = HAVE_ctzv1sf2;
  ena[662] = HAVE_ctzv2sf2;
  ena[663] = HAVE_ctzv1df2;
  ena[664] = HAVE_ctzv4sf2;
  ena[665] = HAVE_ctzv2df2;
  ena[666] = HAVE_popcountqi2;
  ena[667] = HAVE_popcounthi2;
  ena[668] = HAVE_popcountsi2;
  ena[669] = HAVE_popcountdi2;
  ena[670] = HAVE_popcountv16qi2;
  ena[671] = HAVE_popcountv8hi2;
  ena[672] = HAVE_popcountv4si2;
  ena[673] = HAVE_popcountv2di2;
  ena[674] = HAVE_sqrtsf2;
  ena[675] = HAVE_sqrtdf2;
  ena[676] = HAVE_sqrttf2;
  ena[677] = HAVE_sqrtv4sf2;
  ena[678] = HAVE_sqrtv2df2;
  ena[679] = HAVE_sqrtv1tf2;
  ena[680] = HAVE_movcc;
  ena[681] = HAVE_movqi;
  ena[682] = HAVE_movhi;
  ena[683] = HAVE_movsi;
  ena[684] = HAVE_movdi;
  ena[685] = HAVE_movti;
  ena[686] = HAVE_movsf;
  ena[687] = HAVE_movdf;
  ena[688] = HAVE_movtf;
  ena[689] = HAVE_movsd;
  ena[690] = HAVE_movdd;
  ena[691] = HAVE_movtd;
  ena[692] = HAVE_movv1qi;
  ena[693] = HAVE_movv2qi;
  ena[694] = HAVE_movv1hi;
  ena[695] = HAVE_movv4qi;
  ena[696] = HAVE_movv2hi;
  ena[697] = HAVE_movv1si;
  ena[698] = HAVE_movv8qi;
  ena[699] = HAVE_movv4hi;
  ena[700] = HAVE_movv2si;
  ena[701] = HAVE_movv1di;
  ena[702] = HAVE_movv16qi;
  ena[703] = HAVE_movv8hi;
  ena[704] = HAVE_movv4si;
  ena[705] = HAVE_movv2di;
  ena[706] = HAVE_movv1ti;
  ena[707] = HAVE_movv1sf;
  ena[708] = HAVE_movv2sf;
  ena[709] = HAVE_movv1df;
  ena[710] = HAVE_movv4sf;
  ena[711] = HAVE_movv2df;
  ena[712] = HAVE_movv1tf;
  ena[713] = HAVE_movstrictsi;
  ena[714] = HAVE_cbranchcc4;
  ena[715] = HAVE_cbranchsi4;
  ena[716] = HAVE_cbranchdi4;
  ena[717] = HAVE_cbranchsf4;
  ena[718] = HAVE_cbranchdf4;
  ena[719] = HAVE_cbranchtf4;
  ena[720] = HAVE_cbranchdd4;
  ena[721] = HAVE_cbranchtd4;
  ena[722] = HAVE_addsicc;
  ena[723] = HAVE_adddicc;
  ena[724] = HAVE_movsicc;
  ena[725] = HAVE_movdicc;
  ena[726] = HAVE_cstorecc4;
  ena[727] = HAVE_cstoresi4;
  ena[728] = HAVE_cstoredi4;
  ena[729] = HAVE_ctrapsi4;
  ena[730] = HAVE_ctrapdi4;
  ena[731] = HAVE_ctrapsf4;
  ena[732] = HAVE_ctrapdf4;
  ena[733] = HAVE_ctraptf4;
  ena[734] = HAVE_ctrapdd4;
  ena[735] = HAVE_ctraptd4;
  ena[736] = HAVE_addptrsi3;
  ena[737] = HAVE_addptrdi3;
  ena[738] = HAVE_cmpmemsi;
  ena[739] = HAVE_cmpstrsi;
  ena[740] = HAVE_movmemsi;
  ena[741] = HAVE_movmemdi;
  ena[742] = HAVE_setmemsi;
  ena[743] = HAVE_setmemdi;
  ena[744] = HAVE_strlensi;
  ena[745] = HAVE_strlendi;
  ena[746] = HAVE_fmasf4;
  ena[747] = HAVE_fmadf4;
  ena[748] = HAVE_fmav4sf4;
  ena[749] = HAVE_fmav2df4;
  ena[750] = HAVE_fmav1tf4;
  ena[751] = HAVE_fmssf4;
  ena[752] = HAVE_fmsdf4;
  ena[753] = HAVE_fmsv4sf4;
  ena[754] = HAVE_fmsv2df4;
  ena[755] = HAVE_fmsv1tf4;
  ena[756] = HAVE_rintsf2;
  ena[757] = HAVE_rintdf2;
  ena[758] = HAVE_rinttf2;
  ena[759] = HAVE_rintdd2;
  ena[760] = HAVE_rinttd2;
  ena[761] = HAVE_roundsf2;
  ena[762] = HAVE_rounddf2;
  ena[763] = HAVE_roundtf2;
  ena[764] = HAVE_rounddd2;
  ena[765] = HAVE_roundtd2;
  ena[766] = HAVE_floorsf2;
  ena[767] = HAVE_floordf2;
  ena[768] = HAVE_floortf2;
  ena[769] = HAVE_floordd2;
  ena[770] = HAVE_floortd2;
  ena[771] = HAVE_ceilsf2;
  ena[772] = HAVE_ceildf2;
  ena[773] = HAVE_ceiltf2;
  ena[774] = HAVE_ceildd2;
  ena[775] = HAVE_ceiltd2;
  ena[776] = HAVE_btruncsf2;
  ena[777] = HAVE_btruncdf2;
  ena[778] = HAVE_btrunctf2;
  ena[779] = HAVE_btruncdd2;
  ena[780] = HAVE_btrunctd2;
  ena[781] = HAVE_nearbyintsf2;
  ena[782] = HAVE_nearbyintdf2;
  ena[783] = HAVE_nearbyinttf2;
  ena[784] = HAVE_nearbyintdd2;
  ena[785] = HAVE_nearbyinttd2;
  ena[786] = HAVE_copysignsf3;
  ena[787] = HAVE_copysigndf3;
  ena[788] = HAVE_copysigntf3;
  ena[789] = HAVE_copysigndd3;
  ena[790] = HAVE_copysigntd3;
  ena[791] = HAVE_isinfsf2;
  ena[792] = HAVE_isinfdf2;
  ena[793] = HAVE_isinftf2;
  ena[794] = HAVE_isinfsd2;
  ena[795] = HAVE_isinfdd2;
  ena[796] = HAVE_isinftd2;
  ena[797] = HAVE_signbitsf2;
  ena[798] = HAVE_signbitdf2;
  ena[799] = HAVE_signbittf2;
  ena[800] = HAVE_signbitsd2;
  ena[801] = HAVE_signbitdd2;
  ena[802] = HAVE_signbittd2;
  ena[803] = HAVE_vec_extractv1qi;
  ena[804] = HAVE_vec_extractv2qi;
  ena[805] = HAVE_vec_extractv1hi;
  ena[806] = HAVE_vec_extractv4qi;
  ena[807] = HAVE_vec_extractv2hi;
  ena[808] = HAVE_vec_extractv1si;
  ena[809] = HAVE_vec_extractv8qi;
  ena[810] = HAVE_vec_extractv4hi;
  ena[811] = HAVE_vec_extractv2si;
  ena[812] = HAVE_vec_extractv1di;
  ena[813] = HAVE_vec_extractv16qi;
  ena[814] = HAVE_vec_extractv8hi;
  ena[815] = HAVE_vec_extractv4si;
  ena[816] = HAVE_vec_extractv2di;
  ena[817] = HAVE_vec_extractv1sf;
  ena[818] = HAVE_vec_extractv2sf;
  ena[819] = HAVE_vec_extractv1df;
  ena[820] = HAVE_vec_extractv4sf;
  ena[821] = HAVE_vec_extractv2df;
  ena[822] = HAVE_vec_initv16qi;
  ena[823] = HAVE_vec_initv8hi;
  ena[824] = HAVE_vec_initv4si;
  ena[825] = HAVE_vec_initv2di;
  ena[826] = HAVE_vec_initv1ti;
  ena[827] = HAVE_vec_initv4sf;
  ena[828] = HAVE_vec_initv2df;
  ena[829] = HAVE_vec_initv1tf;
  ena[830] = HAVE_vec_pack_ssat_v8hi;
  ena[831] = HAVE_vec_pack_ssat_v4si;
  ena[832] = HAVE_vec_pack_ssat_v2di;
  ena[833] = HAVE_vec_pack_trunc_v8hi;
  ena[834] = HAVE_vec_pack_trunc_v4si;
  ena[835] = HAVE_vec_pack_trunc_v2di;
  ena[836] = HAVE_vec_pack_usat_v8hi;
  ena[837] = HAVE_vec_pack_usat_v4si;
  ena[838] = HAVE_vec_pack_usat_v2di;
  ena[839] = HAVE_vec_permv16qi;
  ena[840] = HAVE_vec_setv1qi;
  ena[841] = HAVE_vec_setv2qi;
  ena[842] = HAVE_vec_setv1hi;
  ena[843] = HAVE_vec_setv4qi;
  ena[844] = HAVE_vec_setv2hi;
  ena[845] = HAVE_vec_setv1si;
  ena[846] = HAVE_vec_setv8qi;
  ena[847] = HAVE_vec_setv4hi;
  ena[848] = HAVE_vec_setv2si;
  ena[849] = HAVE_vec_setv1di;
  ena[850] = HAVE_vec_setv16qi;
  ena[851] = HAVE_vec_setv8hi;
  ena[852] = HAVE_vec_setv4si;
  ena[853] = HAVE_vec_setv2di;
  ena[854] = HAVE_vec_setv1sf;
  ena[855] = HAVE_vec_setv2sf;
  ena[856] = HAVE_vec_setv1df;
  ena[857] = HAVE_vec_setv4sf;
  ena[858] = HAVE_vec_setv2df;
  ena[859] = HAVE_vec_unpacks_hi_v16qi;
  ena[860] = HAVE_vec_unpacks_hi_v8hi;
  ena[861] = HAVE_vec_unpacks_hi_v4si;
  ena[862] = HAVE_vec_unpacks_lo_v8hi;
  ena[863] = HAVE_vec_unpacks_lo_v4si;
  ena[864] = HAVE_vec_unpacku_hi_v16qi;
  ena[865] = HAVE_vec_unpacku_hi_v8hi;
  ena[866] = HAVE_vec_unpacku_hi_v4si;
  ena[867] = HAVE_vec_unpacku_lo_v8hi;
  ena[868] = HAVE_vec_unpacku_lo_v4si;
  ena[869] = HAVE_vec_widen_smult_even_v1qi;
  ena[870] = HAVE_vec_widen_smult_even_v2qi;
  ena[871] = HAVE_vec_widen_smult_even_v1hi;
  ena[872] = HAVE_vec_widen_smult_even_v4qi;
  ena[873] = HAVE_vec_widen_smult_even_v2hi;
  ena[874] = HAVE_vec_widen_smult_even_v1si;
  ena[875] = HAVE_vec_widen_smult_even_v8qi;
  ena[876] = HAVE_vec_widen_smult_even_v4hi;
  ena[877] = HAVE_vec_widen_smult_even_v2si;
  ena[878] = HAVE_vec_widen_smult_even_v16qi;
  ena[879] = HAVE_vec_widen_smult_even_v8hi;
  ena[880] = HAVE_vec_widen_smult_even_v4si;
  ena[881] = HAVE_vec_widen_smult_odd_v1qi;
  ena[882] = HAVE_vec_widen_smult_odd_v2qi;
  ena[883] = HAVE_vec_widen_smult_odd_v1hi;
  ena[884] = HAVE_vec_widen_smult_odd_v4qi;
  ena[885] = HAVE_vec_widen_smult_odd_v2hi;
  ena[886] = HAVE_vec_widen_smult_odd_v1si;
  ena[887] = HAVE_vec_widen_smult_odd_v8qi;
  ena[888] = HAVE_vec_widen_smult_odd_v4hi;
  ena[889] = HAVE_vec_widen_smult_odd_v2si;
  ena[890] = HAVE_vec_widen_smult_odd_v16qi;
  ena[891] = HAVE_vec_widen_smult_odd_v8hi;
  ena[892] = HAVE_vec_widen_smult_odd_v4si;
  ena[893] = HAVE_vec_widen_umult_even_v1qi;
  ena[894] = HAVE_vec_widen_umult_even_v2qi;
  ena[895] = HAVE_vec_widen_umult_even_v1hi;
  ena[896] = HAVE_vec_widen_umult_even_v4qi;
  ena[897] = HAVE_vec_widen_umult_even_v2hi;
  ena[898] = HAVE_vec_widen_umult_even_v1si;
  ena[899] = HAVE_vec_widen_umult_even_v8qi;
  ena[900] = HAVE_vec_widen_umult_even_v4hi;
  ena[901] = HAVE_vec_widen_umult_even_v2si;
  ena[902] = HAVE_vec_widen_umult_even_v16qi;
  ena[903] = HAVE_vec_widen_umult_even_v8hi;
  ena[904] = HAVE_vec_widen_umult_even_v4si;
  ena[905] = HAVE_vec_widen_umult_odd_v1qi;
  ena[906] = HAVE_vec_widen_umult_odd_v2qi;
  ena[907] = HAVE_vec_widen_umult_odd_v1hi;
  ena[908] = HAVE_vec_widen_umult_odd_v4qi;
  ena[909] = HAVE_vec_widen_umult_odd_v2hi;
  ena[910] = HAVE_vec_widen_umult_odd_v1si;
  ena[911] = HAVE_vec_widen_umult_odd_v8qi;
  ena[912] = HAVE_vec_widen_umult_odd_v4hi;
  ena[913] = HAVE_vec_widen_umult_odd_v2si;
  ena[914] = HAVE_vec_widen_umult_odd_v16qi;
  ena[915] = HAVE_vec_widen_umult_odd_v8hi;
  ena[916] = HAVE_vec_widen_umult_odd_v4si;
  ena[917] = HAVE_atomic_add_fetchqi;
  ena[918] = HAVE_atomic_add_fetchhi;
  ena[919] = HAVE_atomic_addqi;
  ena[920] = HAVE_atomic_addhi;
  ena[921] = HAVE_atomic_and_fetchqi;
  ena[922] = HAVE_atomic_and_fetchhi;
  ena[923] = HAVE_atomic_andqi;
  ena[924] = HAVE_atomic_andhi;
  ena[925] = HAVE_atomic_compare_and_swapqi;
  ena[926] = HAVE_atomic_compare_and_swaphi;
  ena[927] = HAVE_atomic_compare_and_swapsi;
  ena[928] = HAVE_atomic_compare_and_swapdi;
  ena[929] = HAVE_atomic_compare_and_swapti;
  ena[930] = HAVE_atomic_exchangeqi;
  ena[931] = HAVE_atomic_exchangehi;
  ena[932] = HAVE_atomic_exchangesi;
  ena[933] = HAVE_atomic_exchangedi;
  ena[934] = HAVE_atomic_exchangeti;
  ena[935] = HAVE_atomic_fetch_addqi;
  ena[936] = HAVE_atomic_fetch_addhi;
  ena[937] = HAVE_atomic_fetch_addsi;
  ena[938] = HAVE_atomic_fetch_adddi;
  ena[939] = HAVE_atomic_fetch_andqi;
  ena[940] = HAVE_atomic_fetch_andhi;
  ena[941] = HAVE_atomic_fetch_andsi;
  ena[942] = HAVE_atomic_fetch_anddi;
  ena[943] = HAVE_atomic_fetch_nandqi;
  ena[944] = HAVE_atomic_fetch_nandhi;
  ena[945] = HAVE_atomic_fetch_orqi;
  ena[946] = HAVE_atomic_fetch_orhi;
  ena[947] = HAVE_atomic_fetch_orsi;
  ena[948] = HAVE_atomic_fetch_ordi;
  ena[949] = HAVE_atomic_fetch_subqi;
  ena[950] = HAVE_atomic_fetch_subhi;
  ena[951] = HAVE_atomic_fetch_xorqi;
  ena[952] = HAVE_atomic_fetch_xorhi;
  ena[953] = HAVE_atomic_fetch_xorsi;
  ena[954] = HAVE_atomic_fetch_xordi;
  ena[955] = HAVE_atomic_loadqi;
  ena[956] = HAVE_atomic_loadhi;
  ena[957] = HAVE_atomic_loadsi;
  ena[958] = HAVE_atomic_loaddi;
  ena[959] = HAVE_atomic_loadti;
  ena[960] = HAVE_atomic_nand_fetchqi;
  ena[961] = HAVE_atomic_nand_fetchhi;
  ena[962] = HAVE_atomic_nandqi;
  ena[963] = HAVE_atomic_nandhi;
  ena[964] = HAVE_atomic_or_fetchqi;
  ena[965] = HAVE_atomic_or_fetchhi;
  ena[966] = HAVE_atomic_orqi;
  ena[967] = HAVE_atomic_orhi;
  ena[968] = HAVE_atomic_storeqi;
  ena[969] = HAVE_atomic_storehi;
  ena[970] = HAVE_atomic_storesi;
  ena[971] = HAVE_atomic_storedi;
  ena[972] = HAVE_atomic_storeti;
  ena[973] = HAVE_atomic_sub_fetchqi;
  ena[974] = HAVE_atomic_sub_fetchhi;
  ena[975] = HAVE_atomic_subqi;
  ena[976] = HAVE_atomic_subhi;
  ena[977] = HAVE_atomic_xor_fetchqi;
  ena[978] = HAVE_atomic_xor_fetchhi;
  ena[979] = HAVE_atomic_xorqi;
  ena[980] = HAVE_atomic_xorhi;
  ena[981] = HAVE_get_thread_pointersi;
  ena[982] = HAVE_get_thread_pointerdi;
  ena[983] = HAVE_set_thread_pointersi;
  ena[984] = HAVE_set_thread_pointerdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

